/* bluetooth.c generated by valac 0.56.12, the Vala compiler
 * generated from bluetooth.vala, do not modify */

/*
 * Copyright 2013 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *   Charles Kerr <charles.kerr@canonical.com>
 */

#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BLUETOOTH (bluetooth_get_type ())
#define BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLUETOOTH, Bluetooth))
#define IS_BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLUETOOTH))
#define BLUETOOTH_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BLUETOOTH, BluetoothIface))

typedef struct _Bluetooth Bluetooth;
typedef struct _BluetoothIface BluetoothIface;

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
enum  {
	BLUETOOTH_DEVICES_CHANGED_SIGNAL,
	BLUETOOTH_NUM_SIGNALS
};
static guint bluetooth_signals[BLUETOOTH_NUM_SIGNALS] = {0};

struct _BluetoothIface {
	GTypeInterface parent_iface;
	void (*try_set_enabled) (Bluetooth* self, gboolean b);
	void (*try_set_discoverable) (Bluetooth* self, gboolean discoverable);
	GList* (*get_devices) (Bluetooth* self);
	void (*set_device_connected) (Bluetooth* self, guint device_key, gboolean connected);
	gboolean (*get_supported) (Bluetooth* self);
	void (*set_supported) (Bluetooth* self, gboolean value);
	gboolean (*get_enabled) (Bluetooth* self);
	void (*set_enabled) (Bluetooth* self, gboolean value);
	gboolean (*get_connected) (Bluetooth* self);
	void (*set_connected) (Bluetooth* self, gboolean value);
	gboolean (*get_discoverable) (Bluetooth* self);
	void (*set_discoverable) (Bluetooth* self, gboolean value);
};

VALA_EXTERN GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
VALA_EXTERN GType bluetooth_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bluetooth, g_object_unref)
VALA_EXTERN void bluetooth_try_set_enabled (Bluetooth* self,
                                gboolean b);
VALA_EXTERN void bluetooth_try_set_discoverable (Bluetooth* self,
                                     gboolean discoverable);
VALA_EXTERN GList* bluetooth_get_devices (Bluetooth* self);
VALA_EXTERN void bluetooth_set_device_connected (Bluetooth* self,
                                     guint device_key,
                                     gboolean connected);
VALA_EXTERN gboolean bluetooth_get_supported (Bluetooth* self);
VALA_EXTERN void bluetooth_set_supported (Bluetooth* self,
                              gboolean value);
VALA_EXTERN gboolean bluetooth_get_enabled (Bluetooth* self);
VALA_EXTERN void bluetooth_set_enabled (Bluetooth* self,
                            gboolean value);
VALA_EXTERN gboolean bluetooth_get_connected (Bluetooth* self);
VALA_EXTERN void bluetooth_set_connected (Bluetooth* self,
                              gboolean value);
VALA_EXTERN gboolean bluetooth_get_discoverable (Bluetooth* self);
VALA_EXTERN void bluetooth_set_discoverable (Bluetooth* self,
                                 gboolean value);
static GType bluetooth_get_type_once (void);

void
bluetooth_try_set_enabled (Bluetooth* self,
                           gboolean b)
{
	BluetoothIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->try_set_enabled) {
		_iface_->try_set_enabled (self, b);
	}
}

void
bluetooth_try_set_discoverable (Bluetooth* self,
                                gboolean discoverable)
{
	BluetoothIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->try_set_discoverable) {
		_iface_->try_set_discoverable (self, discoverable);
	}
}

GList*
bluetooth_get_devices (Bluetooth* self)
{
	BluetoothIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->get_devices) {
		return _iface_->get_devices (self);
	}
	return NULL;
}

void
bluetooth_set_device_connected (Bluetooth* self,
                                guint device_key,
                                gboolean connected)
{
	BluetoothIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->set_device_connected) {
		_iface_->set_device_connected (self, device_key, connected);
	}
}

gboolean
bluetooth_get_supported (Bluetooth* self)
{
	BluetoothIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->get_supported) {
		return _iface_->get_supported (self);
	}
	return FALSE;
}

void
bluetooth_set_supported (Bluetooth* self,
                         gboolean value)
{
	BluetoothIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->set_supported) {
		_iface_->set_supported (self, value);
	}
}

gboolean
bluetooth_get_enabled (Bluetooth* self)
{
	BluetoothIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->get_enabled) {
		return _iface_->get_enabled (self);
	}
	return FALSE;
}

void
bluetooth_set_enabled (Bluetooth* self,
                       gboolean value)
{
	BluetoothIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->set_enabled) {
		_iface_->set_enabled (self, value);
	}
}

gboolean
bluetooth_get_connected (Bluetooth* self)
{
	BluetoothIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->get_connected) {
		return _iface_->get_connected (self);
	}
	return FALSE;
}

void
bluetooth_set_connected (Bluetooth* self,
                         gboolean value)
{
	BluetoothIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->set_connected) {
		_iface_->set_connected (self, value);
	}
}

gboolean
bluetooth_get_discoverable (Bluetooth* self)
{
	BluetoothIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->get_discoverable) {
		return _iface_->get_discoverable (self);
	}
	return FALSE;
}

void
bluetooth_set_discoverable (Bluetooth* self,
                            gboolean value)
{
	BluetoothIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = BLUETOOTH_GET_INTERFACE (self);
	if (_iface_->set_discoverable) {
		_iface_->set_discoverable (self, value);
	}
}

static void
bluetooth_default_init (BluetoothIface * iface,
                        gpointer iface_data)
{
	g_object_interface_install_property (iface, g_param_spec_boolean ("supported", "supported", "supported", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_interface_install_property (iface, g_param_spec_boolean ("enabled", "enabled", "enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_interface_install_property (iface, g_param_spec_boolean ("connected", "connected", "connected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_interface_install_property (iface, g_param_spec_boolean ("discoverable", "discoverable", "discoverable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	bluetooth_signals[BLUETOOTH_DEVICES_CHANGED_SIGNAL] = g_signal_new ("devices-changed", TYPE_BLUETOOTH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

/**
 * Abstract interface for the Bluetooth backend.
 */
static GType
bluetooth_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType bluetooth_type_id;
	bluetooth_type_id = g_type_register_static (G_TYPE_INTERFACE, "Bluetooth", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (bluetooth_type_id, G_TYPE_OBJECT);
	return bluetooth_type_id;
}

GType
bluetooth_get_type (void)
{
	static volatile gsize bluetooth_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_type_id__once)) {
		GType bluetooth_type_id;
		bluetooth_type_id = bluetooth_get_type_once ();
		g_once_init_leave (&bluetooth_type_id__once, bluetooth_type_id);
	}
	return bluetooth_type_id__once;
}

