/* desktop.c generated by valac 0.56.12, the Vala compiler
 * generated from desktop.vala, do not modify */

/*
 * Copyright 2013 Canonical Ltd.
 * Copyright 2021-2022 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *   Charles Kerr <charles.kerr@canonical.com>
 *   Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <ayatana/common/utils.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PROFILE (profile_get_type ())
#define PROFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROFILE, Profile))
#define PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROFILE, ProfileClass))
#define IS_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROFILE))
#define IS_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROFILE))
#define PROFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROFILE, ProfileClass))

typedef struct _Profile Profile;
typedef struct _ProfileClass ProfileClass;
typedef struct _ProfilePrivate ProfilePrivate;

#define TYPE_BLUETOOTH (bluetooth_get_type ())
#define BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLUETOOTH, Bluetooth))
#define IS_BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLUETOOTH))
#define BLUETOOTH_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BLUETOOTH, BluetoothIface))

typedef struct _Bluetooth Bluetooth;
typedef struct _BluetoothIface BluetoothIface;

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;

#define TYPE_DESKTOP (desktop_get_type ())
#define DESKTOP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DESKTOP, Desktop))
#define DESKTOP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DESKTOP, DesktopClass))
#define IS_DESKTOP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DESKTOP))
#define IS_DESKTOP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DESKTOP))
#define DESKTOP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DESKTOP, DesktopClass))

typedef struct _Desktop Desktop;
typedef struct _DesktopClass DesktopClass;
typedef struct _DesktopPrivate DesktopPrivate;
enum  {
	DESKTOP_0_PROPERTY,
	DESKTOP_NUM_PROPERTIES
};
static GParamSpec* desktop_properties[DESKTOP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	DEVICE_TYPE_OTHER,
	DEVICE_TYPE_COMPUTER,
	DEVICE_TYPE_PHONE,
	DEVICE_TYPE_MODEM,
	DEVICE_TYPE_NETWORK,
	DEVICE_TYPE_HEADSET,
	DEVICE_TYPE_HEADPHONES,
	DEVICE_TYPE_VIDEO,
	DEVICE_TYPE_OTHER_AUDIO,
	DEVICE_TYPE_JOYPAD,
	DEVICE_TYPE_KEYPAD,
	DEVICE_TYPE_KEYBOARD,
	DEVICE_TYPE_TABLET,
	DEVICE_TYPE_MOUSE,
	DEVICE_TYPE_PRINTER,
	DEVICE_TYPE_CAMERA
} DeviceType;

#define DEVICE_TYPE_TYPE (device_type_get_type ())
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _BluetoothIface {
	GTypeInterface parent_iface;
	void (*try_set_enabled) (Bluetooth* self, gboolean b);
	void (*try_set_discoverable) (Bluetooth* self, gboolean discoverable);
	GList* (*get_devices) (Bluetooth* self);
	void (*set_device_connected) (Bluetooth* self, guint device_key, gboolean connected);
	gboolean (*get_supported) (Bluetooth* self);
	void (*set_supported) (Bluetooth* self, gboolean value);
	gboolean (*get_enabled) (Bluetooth* self);
	void (*set_enabled) (Bluetooth* self, gboolean value);
	gboolean (*get_connected) (Bluetooth* self);
	void (*set_connected) (Bluetooth* self, gboolean value);
	gboolean (*get_discoverable) (Bluetooth* self);
	void (*set_discoverable) (Bluetooth* self, gboolean value);
};

struct _Profile {
	GObject parent_instance;
	ProfilePrivate * priv;
	Bluetooth* bluetooth;
	gchar* profile_name;
	GMenu* root;
	GMenu* menu;
	GSimpleAction* root_action;
};

struct _ProfileClass {
	GObjectClass parent_class;
};

struct _Desktop {
	Profile parent_instance;
	DesktopPrivate * priv;
};

struct _DesktopClass {
	ProfileClass parent_class;
};

struct _DesktopPrivate {
	guint idle_rebuild_id;
	GSettings* settings;
	GSimpleActionGroup* action_group;
	GMenu* device_section;
	GHashTable* connect_actions;
};

struct _Block1Data {
	int _ref_count_;
	Desktop* self;
	guint id;
};

struct _Block2Data {
	int _ref_count_;
	Block1Data * _data1_;
	GSimpleAction* a;
};

struct _Block3Data {
	int _ref_count_;
	Desktop* self;
	GSimpleAction* action;
	Bluetooth* bluetooth;
};

struct _Block4Data {
	int _ref_count_;
	Desktop* self;
	gchar* uri;
};

static gint Desktop_private_offset;
static gpointer desktop_parent_class = NULL;

VALA_EXTERN GType profile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Profile, g_object_unref)
VALA_EXTERN GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
VALA_EXTERN GType bluetooth_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bluetooth, g_object_unref)
VALA_EXTERN GType desktop_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Desktop, g_object_unref)
static void desktop_real_dispose (GObject* base);
VALA_EXTERN Desktop* desktop_new (Bluetooth* bluetooth,
                      GSimpleActionGroup* action_group);
VALA_EXTERN Desktop* desktop_construct (GType object_type,
                            Bluetooth* bluetooth,
                            GSimpleActionGroup* action_group);
VALA_EXTERN Profile* profile_new (Bluetooth* bluetooth,
                      const gchar* profile_name);
VALA_EXTERN Profile* profile_construct (GType object_type,
                            Bluetooth* bluetooth,
                            const gchar* profile_name);
static void _g_object_unref0_ (gpointer var);
static void _vala_array_add1 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
VALA_EXTERN GAction* profile_create_supported_action (Profile* self,
                                          Bluetooth* bluetooth);
static void _vala_array_add2 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
VALA_EXTERN GAction* profile_create_enabled_action (Profile* self,
                                        Bluetooth* bluetooth);
static void _vala_array_add3 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
static GAction* desktop_create_discoverable_action (Desktop* self,
                                             Bluetooth* bluetooth);
static void _vala_array_add4 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
static GAction* desktop_create_browse_files_action (Desktop* self);
static void _vala_array_add5 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
static GAction* desktop_create_send_file_action (Desktop* self);
static void _vala_array_add6 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
static GAction* desktop_create_show_settings_action (Desktop* self);
static void _vala_array_add7 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
static void _vala_array_add8 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
static void desktop_build_menu (Desktop* self);
static void ___lambda13_ (Desktop* self);
static void desktop_update_visibility (Desktop* self);
static void ____lambda13__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void ___lambda14_ (Desktop* self);
static void ____lambda14__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void ___lambda15_ (Desktop* self);
VALA_EXTERN void profile_update_root_action_state (Profile* self);
static void ____lambda15__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda16_ (Desktop* self);
static gboolean ___lambda17_ (Desktop* self);
static void desktop_rebuild_device_section (Desktop* self);
static gboolean ____lambda17__gsource_func (gpointer self);
static void ___lambda16__bluetooth_devices_changed (Bluetooth* _sender,
                                             gpointer self);
VALA_EXTERN gboolean bluetooth_get_supported (Bluetooth* self);
VALA_EXTERN void profile_set_visible (Profile* self,
                          gboolean value);
static GMenuItem* desktop_create_device_connection_menuitem (Desktop* self,
                                                      Device* device);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
VALA_EXTERN guint device_get_id (Device* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN gboolean device_get_is_connected (Device* self);
static void ___lambda11_ (Block2Data* _data2_,
                   GSimpleAction* action,
                   GVariant* param);
static void ____lambda11__g_simple_action_activate (GSimpleAction* _sender,
                                             GVariant* parameter,
                                             gpointer self);
static void ___lambda12_ (Block2Data* _data2_,
                   GSimpleAction* action,
                   GVariant* requestedValue);
VALA_EXTERN void bluetooth_set_device_connected (Bluetooth* self,
                                     guint device_key,
                                     gboolean connected);
static void ____lambda12__g_simple_action_change_state (GSimpleAction* _sender,
                                                 GVariant* value,
                                                 gpointer self);
VALA_EXTERN GList* bluetooth_get_devices (Bluetooth* self);
VALA_EXTERN gboolean device_get_is_connectable (Device* self);
VALA_EXTERN gboolean device_get_supports_file_transfer (Device* self);
VALA_EXTERN const gchar* device_get_address (Device* self);
VALA_EXTERN GType device_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN DeviceType device_get_device_type (Device* self);
VALA_EXTERN const gchar* device_get_name (Device* self);
VALA_EXTERN GIcon* device_get_icon (Device* self);
VALA_EXTERN GMenuItem* profile_create_enabled_menuitem (Profile* self);
static void desktop_show_settings (Desktop* self,
                            const gchar* panel);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN gboolean bluetooth_get_discoverable (Bluetooth* self);
static void __lambda4_ (Desktop* self,
                 GSimpleAction* action,
                 GVariant* param);
static void ___lambda4__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
static void __lambda5_ (Block3Data* _data3_,
                 GSimpleAction* action,
                 GVariant* requestedValue);
VALA_EXTERN void bluetooth_try_set_discoverable (Bluetooth* self,
                                     gboolean discoverable);
static void ___lambda5__g_simple_action_change_state (GSimpleAction* _sender,
                                               GVariant* value,
                                               gpointer self);
static void __lambda6_ (Block3Data* _data3_);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (Desktop* self,
                 GSimpleAction* action,
                 GVariant* address);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda8_ (Block4Data* _data4_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda8__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void ___lambda7__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
static void __lambda9_ (Desktop* self,
                 GSimpleAction* action,
                 GVariant* address);
VALA_EXTERN void profile_spawn_command_line_async (Profile* self,
                                       const gchar* command);
static void ___lambda9__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
static void __lambda10_ (Desktop* self,
                  GSimpleAction* action,
                  GVariant* panel);
static void ___lambda10__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static void desktop_finalize (GObject * obj);
static GType desktop_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
desktop_get_instance_private (Desktop* self)
{
	return G_STRUCT_MEMBER_P (self, Desktop_private_offset);
}

static void
desktop_real_dispose (GObject* base)
{
	Desktop * self;
	self = (Desktop*) base;
	if (self->priv->idle_rebuild_id != ((guint) 0)) {
		g_source_remove (self->priv->idle_rebuild_id);
		self->priv->idle_rebuild_id = (guint) 0;
	}
	G_OBJECT_CLASS (desktop_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PROFILE, Profile));
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static void
_vala_array_add1 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add3 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add5 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add6 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add7 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add8 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
___lambda13_ (Desktop* self)
{
	desktop_update_visibility (self);
}

static void
____lambda13__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	___lambda13_ ((Desktop*) self);
}

static void
___lambda14_ (Desktop* self)
{
	desktop_update_visibility (self);
}

static void
____lambda14__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda14_ ((Desktop*) self);
}

static void
___lambda15_ (Desktop* self)
{
	profile_update_root_action_state ((Profile*) self);
}

static void
____lambda15__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda15_ ((Desktop*) self);
}

static gboolean
___lambda17_ (Desktop* self)
{
	gboolean result;
	desktop_rebuild_device_section (self);
	self->priv->idle_rebuild_id = (guint) 0;
	result = FALSE;
	return result;
}

static gboolean
____lambda17__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda17_ ((Desktop*) self);
	return result;
}

static void
__lambda16_ (Desktop* self)
{
	if (self->priv->idle_rebuild_id == ((guint) 0)) {
		self->priv->idle_rebuild_id = g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda17__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static void
___lambda16__bluetooth_devices_changed (Bluetooth* _sender,
                                        gpointer self)
{
	__lambda16_ ((Desktop*) self);
}

Desktop*
desktop_construct (GType object_type,
                   Bluetooth* bluetooth,
                   GSimpleActionGroup* action_group)
{
	Desktop * self = NULL;
	static const char profile_name[] = "desktop";
	GSimpleActionGroup* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
	GSettings* _tmp4_;
	GAction** actions = NULL;
	GAction** _tmp5_;
	gint actions_length1;
	gint _actions_size_;
	GSimpleAction* _tmp6_;
	GAction* _tmp7_;
	GAction* _tmp8_;
	GAction* _tmp9_;
	GAction* _tmp10_;
	GAction* _tmp11_;
	GAction* _tmp12_;
	GAction* _tmp13_;
	GAction** _tmp19_;
	gint _tmp19__length1;
	g_return_val_if_fail (bluetooth != NULL, NULL);
	g_return_val_if_fail (action_group != NULL, NULL);
	self = (Desktop*) profile_construct (object_type, bluetooth, profile_name);
	_tmp0_ = _g_object_ref0 (action_group);
	_g_object_unref0 (self->priv->action_group);
	self->priv->action_group = _tmp0_;
	_tmp1_ = g_direct_hash;
	_tmp2_ = g_direct_equal;
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, NULL, _g_object_unref0_);
	_g_hash_table_unref0 (self->priv->connect_actions);
	self->priv->connect_actions = _tmp3_;
	_tmp4_ = g_settings_new ("org.ayatana.indicator.bluetooth");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp4_;
	_tmp5_ = g_new0 (GAction*, 0 + 1);
	actions = _tmp5_;
	actions_length1 = 0;
	_actions_size_ = actions_length1;
	_tmp6_ = ((Profile*) self)->root_action;
	_tmp7_ = _g_object_ref0 ((GAction*) _tmp6_);
	_vala_array_add1 (&actions, &actions_length1, &_actions_size_, _tmp7_);
	_tmp8_ = profile_create_supported_action ((Profile*) self, bluetooth);
	_vala_array_add2 (&actions, &actions_length1, &_actions_size_, _tmp8_);
	_tmp9_ = profile_create_enabled_action ((Profile*) self, bluetooth);
	_vala_array_add3 (&actions, &actions_length1, &_actions_size_, _tmp9_);
	_tmp10_ = desktop_create_discoverable_action (self, bluetooth);
	_vala_array_add4 (&actions, &actions_length1, &_actions_size_, _tmp10_);
	_tmp11_ = desktop_create_browse_files_action (self);
	_vala_array_add5 (&actions, &actions_length1, &_actions_size_, _tmp11_);
	_tmp12_ = desktop_create_send_file_action (self);
	_vala_array_add6 (&actions, &actions_length1, &_actions_size_, _tmp12_);
	_tmp13_ = desktop_create_show_settings_action (self);
	_vala_array_add7 (&actions, &actions_length1, &_actions_size_, _tmp13_);
	if (!ayatana_common_utils_is_lomiri ()) {
		GSimpleAction* pAction = NULL;
		const GVariantType* _tmp14_;
		GSimpleAction* _tmp15_;
		GSimpleAction* _tmp16_;
		GSimpleAction* _tmp17_;
		GAction* _tmp18_;
		_tmp14_ = G_VARIANT_TYPE_BOOLEAN;
		_tmp15_ = g_simple_action_new ("item-enabled", _tmp14_);
		pAction = _tmp15_;
		_tmp16_ = pAction;
		g_simple_action_set_enabled (_tmp16_, FALSE);
		_tmp17_ = pAction;
		_tmp18_ = _g_object_ref0 ((GAction*) _tmp17_);
		_vala_array_add8 (&actions, &actions_length1, &_actions_size_, _tmp18_);
		_g_object_unref0 (pAction);
	}
	_tmp19_ = actions;
	_tmp19__length1 = actions_length1;
	{
		GAction** a_collection = NULL;
		gint a_collection_length1 = 0;
		gint _a_collection_size_ = 0;
		gint a_it = 0;
		a_collection = _tmp19_;
		a_collection_length1 = _tmp19__length1;
		for (a_it = 0; a_it < a_collection_length1; a_it = a_it + 1) {
			GAction* _tmp20_;
			GAction* a = NULL;
			_tmp20_ = _g_object_ref0 (a_collection[a_it]);
			a = _tmp20_;
			{
				GAction* _tmp21_;
				_tmp21_ = a;
				g_action_map_add_action ((GActionMap*) action_group, _tmp21_);
				_g_object_unref0 (a);
			}
		}
	}
	desktop_build_menu (self);
	if (ayatana_common_utils_is_lomiri ()) {
		GSettings* _tmp22_;
		_tmp22_ = self->priv->settings;
		g_signal_connect_object (_tmp22_, "changed::visible", (GCallback) ____lambda13__g_settings_changed, self, 0);
		g_signal_connect_object ((GObject*) bluetooth, "notify::supported", (GCallback) ____lambda14__g_object_notify, self, 0);
		desktop_update_visibility (self);
	} else {
		g_signal_connect_object ((GObject*) bluetooth, "notify::supported", (GCallback) ____lambda15__g_object_notify, self, 0);
		profile_update_root_action_state ((Profile*) self);
	}
	g_signal_connect_object (bluetooth, "devices-changed", (GCallback) ___lambda16__bluetooth_devices_changed, self, 0);
	actions = (_vala_array_free (actions, actions_length1, (GDestroyNotify) g_object_unref), NULL);
	return self;
}

Desktop*
desktop_new (Bluetooth* bluetooth,
             GSimpleActionGroup* action_group)
{
	return desktop_construct (TYPE_DESKTOP, bluetooth, action_group);
}

static void
desktop_update_visibility (Desktop* self)
{
	gboolean _tmp0_ = FALSE;
	Bluetooth* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp1_ = ((Profile*) self)->bluetooth;
	_tmp2_ = bluetooth_get_supported (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GSettings* _tmp4_;
		_tmp4_ = self->priv->settings;
		_tmp0_ = g_settings_get_boolean (_tmp4_, "visible");
	} else {
		_tmp0_ = FALSE;
	}
	profile_set_visible ((Profile*) self, _tmp0_);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Desktop* self;
		self = _data1_->self;
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		Desktop* self;
		self = _data2_->_data1_->self;
		_g_object_unref0 (_data2_->a);
		block1_data_unref (_data2_->_data1_);
		_data2_->_data1_ = NULL;
		g_slice_free (Block2Data, _data2_);
	}
}

static void
___lambda11_ (Block2Data* _data2_,
              GSimpleAction* action,
              GVariant* param)
{
	Block1Data* _data1_;
	Desktop* self;
	GSimpleAction* _tmp0_;
	_data1_ = _data2_->_data1_;
	self = _data1_->self;
	g_return_if_fail (action != NULL);
	_tmp0_ = _data2_->a;
	g_signal_emit_by_name (_tmp0_, "change-state", param);
}

static void
____lambda11__g_simple_action_activate (GSimpleAction* _sender,
                                        GVariant* parameter,
                                        gpointer self)
{
	___lambda11_ (self, _sender, parameter);
}

static void
___lambda12_ (Block2Data* _data2_,
              GSimpleAction* action,
              GVariant* requestedValue)
{
	Block1Data* _data1_;
	Desktop* self;
	Bluetooth* _tmp0_;
	_data1_ = _data2_->_data1_;
	self = _data1_->self;
	g_return_if_fail (action != NULL);
	_tmp0_ = ((Profile*) self)->bluetooth;
	bluetooth_set_device_connected (_tmp0_, _data1_->id, g_variant_get_boolean (requestedValue));
}

static void
____lambda12__g_simple_action_change_state (GSimpleAction* _sender,
                                            GVariant* value,
                                            gpointer self)
{
	___lambda12_ (self, _sender, value);
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static GMenuItem*
desktop_create_device_connection_menuitem (Desktop* self,
                                           Device* device)
{
	Block1Data* _data1_;
	guint _tmp0_;
	guint _tmp1_;
	gchar* action_name = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GMenuItem* item = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GMenuItem* _tmp10_;
	GMenuItem* _tmp11_;
	GMenuItem* _tmp12_;
	GHashTable* _tmp13_;
	GMenuItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (device != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = device_get_id (device);
	_tmp1_ = _tmp0_;
	_data1_->id = _tmp1_;
	_tmp2_ = g_strdup_printf ("%u", _data1_->id);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat ("desktop-device-", _tmp3_, "-connected", NULL);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	action_name = _tmp5_;
	_tmp6_ = action_name;
	_tmp7_ = string_to_string (_tmp6_);
	_tmp8_ = g_strconcat ("indicator.", _tmp7_, "(true)", NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_menu_item_new (_ ("Connection"), _tmp9_);
	_tmp11_ = _tmp10_;
	_g_free0 (_tmp9_);
	item = _tmp11_;
	_tmp12_ = item;
	g_menu_item_set_attribute (_tmp12_, "x-ayatana-type", "s", "org.ayatana.indicator.switch", NULL);
	_tmp13_ = self->priv->connect_actions;
	if (!g_hash_table_contains (_tmp13_, (gpointer) ((guintptr) _data1_->id))) {
		Block2Data* _data2_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		const GVariantType* _tmp19_;
		gboolean _tmp20_;
		gboolean _tmp21_;
		GVariant* _tmp22_;
		GVariant* _tmp23_;
		GSimpleAction* _tmp24_;
		GSimpleAction* _tmp25_;
		GSimpleAction* _tmp26_;
		GSimpleAction* _tmp27_;
		GHashTable* _tmp28_;
		guint _tmp29_;
		guint _tmp30_;
		GSimpleAction* _tmp31_;
		GSimpleAction* _tmp32_;
		GSimpleActionGroup* _tmp33_;
		GSimpleAction* _tmp34_;
		_data2_ = g_slice_new0 (Block2Data);
		_data2_->_ref_count_ = 1;
		_data2_->_data1_ = block1_data_ref (_data1_);
		_tmp14_ = action_name;
		_tmp15_ = string_to_string (_tmp14_);
		_tmp16_ = g_strconcat ("creating action for ", _tmp15_, NULL);
		_tmp17_ = _tmp16_;
		g_debug ("desktop.vala:121: %s", _tmp17_);
		_g_free0 (_tmp17_);
		_tmp18_ = action_name;
		_tmp19_ = G_VARIANT_TYPE_BOOLEAN;
		_tmp20_ = device_get_is_connected (device);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_variant_new_boolean (_tmp21_);
		g_variant_ref_sink (_tmp22_);
		_tmp23_ = _tmp22_;
		_tmp24_ = g_simple_action_new_stateful (_tmp18_, _tmp19_, _tmp23_);
		_tmp25_ = _tmp24_;
		_g_variant_unref0 (_tmp23_);
		_data2_->a = _tmp25_;
		_tmp26_ = _data2_->a;
		g_signal_connect_data (_tmp26_, "activate", (GCallback) ____lambda11__g_simple_action_activate, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
		_tmp27_ = _data2_->a;
		g_signal_connect_data (_tmp27_, "change-state", (GCallback) ____lambda12__g_simple_action_change_state, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
		_tmp28_ = self->priv->connect_actions;
		_tmp29_ = device_get_id (device);
		_tmp30_ = _tmp29_;
		_tmp31_ = _data2_->a;
		_tmp32_ = _g_object_ref0 (_tmp31_);
		g_hash_table_insert (_tmp28_, (gpointer) ((guintptr) _tmp30_), _tmp32_);
		_tmp33_ = self->priv->action_group;
		_tmp34_ = _data2_->a;
		g_action_map_add_action ((GActionMap*) _tmp33_, (GAction*) _tmp34_);
		block2_data_unref (_data2_);
		_data2_ = NULL;
	} else {
		guint _tmp35_;
		guint _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gboolean _tmp39_;
		gboolean _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		GSimpleAction* action = NULL;
		GHashTable* _tmp45_;
		guint _tmp46_;
		guint _tmp47_;
		gconstpointer _tmp48_;
		GSimpleAction* _tmp49_;
		GSimpleAction* _tmp50_;
		gboolean _tmp51_;
		gboolean _tmp52_;
		GVariant* _tmp53_;
		GVariant* _tmp54_;
		_tmp35_ = device_get_id (device);
		_tmp36_ = _tmp35_;
		_tmp37_ = g_strdup_printf ("%u", _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = device_get_is_connected (device);
		_tmp40_ = _tmp39_;
		_tmp41_ = bool_to_string (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = g_strconcat ("updating action ", _tmp38_, " state to ", _tmp42_, NULL);
		_tmp44_ = _tmp43_;
		g_debug ("desktop.vala:137: %s", _tmp44_);
		_g_free0 (_tmp44_);
		_g_free0 (_tmp42_);
		_g_free0 (_tmp38_);
		_tmp45_ = self->priv->connect_actions;
		_tmp46_ = device_get_id (device);
		_tmp47_ = _tmp46_;
		_tmp48_ = g_hash_table_lookup (_tmp45_, (gpointer) ((guintptr) _tmp47_));
		_tmp49_ = _g_object_ref0 ((GSimpleAction*) _tmp48_);
		action = _tmp49_;
		_tmp50_ = action;
		_tmp51_ = device_get_is_connected (device);
		_tmp52_ = _tmp51_;
		_tmp53_ = g_variant_new_boolean (_tmp52_);
		g_variant_ref_sink (_tmp53_);
		_tmp54_ = _tmp53_;
		g_simple_action_set_state (_tmp50_, _tmp54_);
		_g_variant_unref0 (_tmp54_);
		_g_object_unref0 (action);
	}
	result = item;
	_g_free0 (action_name);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}

static void
desktop_rebuild_device_section (Desktop* self)
{
	GMenu* _tmp0_;
	Bluetooth* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->device_section;
	g_menu_remove_all (_tmp0_);
	_tmp1_ = ((Profile*) self)->bluetooth;
	_tmp2_ = bluetooth_get_devices (_tmp1_);
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = _tmp2_;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			Device* device = NULL;
			device = (Device*) device_it->data;
			{
				GMenu* submenu = NULL;
				GMenu* _tmp3_;
				GMenuItem* item = NULL;
				Device* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
				Device* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
				Device* _tmp21_;
				DeviceType _tmp22_;
				DeviceType _tmp23_;
				gint nItems = 0;
				GMenu* _tmp27_;
				_tmp3_ = g_menu_new ();
				submenu = _tmp3_;
				_tmp4_ = device;
				_tmp5_ = device_get_is_connectable (_tmp4_);
				_tmp6_ = _tmp5_;
				if (_tmp6_) {
					GMenu* _tmp7_;
					Device* _tmp8_;
					GMenuItem* _tmp9_;
					GMenuItem* _tmp10_;
					_tmp7_ = submenu;
					_tmp8_ = device;
					_tmp9_ = desktop_create_device_connection_menuitem (self, _tmp8_);
					_tmp10_ = _tmp9_;
					g_menu_append_item (_tmp7_, _tmp10_);
					_g_object_unref0 (_tmp10_);
				}
				_tmp11_ = device;
				_tmp12_ = device_get_supports_file_transfer (_tmp11_);
				_tmp13_ = _tmp12_;
				if (_tmp13_) {
					GMenu* _tmp14_;
					Device* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					_tmp14_ = submenu;
					_tmp15_ = device;
					_tmp16_ = device_get_address (_tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = string_to_string (_tmp17_);
					_tmp19_ = g_strconcat ("indicator.desktop-send-file::", _tmp18_, NULL);
					_tmp20_ = _tmp19_;
					g_menu_append (_tmp14_, _ ("Send files…"), _tmp20_);
					_g_free0 (_tmp20_);
				}
				_tmp21_ = device;
				_tmp22_ = device_get_device_type (_tmp21_);
				_tmp23_ = _tmp22_;
				switch (_tmp23_) {
					case DEVICE_TYPE_KEYBOARD:
					{
						GMenu* _tmp24_;
						_tmp24_ = submenu;
						g_menu_append (_tmp24_, _ ("Keyboard Settings…"), "indicator.desktop-show-settings::keyboard");
						break;
					}
					case DEVICE_TYPE_MOUSE:
					case DEVICE_TYPE_TABLET:
					{
						GMenu* _tmp25_;
						_tmp25_ = submenu;
						g_menu_append (_tmp25_, _ ("Mouse and Touchpad Settings…"), "indicator.desktop-show-settings::mouse");
						break;
					}
					case DEVICE_TYPE_HEADSET:
					case DEVICE_TYPE_HEADPHONES:
					case DEVICE_TYPE_OTHER_AUDIO:
					{
						GMenu* _tmp26_;
						_tmp26_ = submenu;
						g_menu_append (_tmp26_, _ ("Sound Settings…"), "indicator.desktop-show-settings::sound");
						break;
					}
					default:
					{
						break;
					}
				}
				_tmp27_ = submenu;
				nItems = g_menu_model_get_n_items ((GMenuModel*) _tmp27_);
				if (nItems > 0) {
					Device* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					GMenuItem* _tmp31_;
					GMenuItem* _tmp32_;
					Device* _tmp33_;
					GIcon* _tmp34_;
					GIcon* _tmp35_;
					GVariant* _tmp36_;
					GVariant* _tmp37_;
					_tmp28_ = device;
					_tmp29_ = device_get_name (_tmp28_);
					_tmp30_ = _tmp29_;
					_tmp31_ = g_menu_item_new (_tmp30_, NULL);
					_g_object_unref0 (item);
					item = _tmp31_;
					_tmp32_ = item;
					_tmp33_ = device;
					_tmp34_ = device_get_icon (_tmp33_);
					_tmp35_ = _tmp34_;
					_tmp36_ = g_icon_serialize (_tmp35_);
					_tmp37_ = _tmp36_;
					g_menu_item_set_attribute_value (_tmp32_, "icon", _tmp37_);
					_g_variant_unref0 (_tmp37_);
					if (ayatana_common_utils_is_lomiri ()) {
						GMenuItem* _tmp38_;
						GMenu* _tmp39_;
						GMenu* _tmp40_;
						GMenuItem* _tmp41_;
						_tmp38_ = item;
						_tmp39_ = submenu;
						g_menu_item_set_submenu (_tmp38_, (GMenuModel*) _tmp39_);
						_tmp40_ = self->priv->device_section;
						_tmp41_ = item;
						g_menu_append_item (_tmp40_, _tmp41_);
					} else {
						GMenuItem* _tmp42_;
						GMenuItem* _tmp43_;
						GMenuItem* _tmp44_;
						GMenuItem* _tmp45_;
						Device* _tmp46_;
						const gchar* _tmp47_;
						const gchar* _tmp48_;
						gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						gchar* _tmp52_;
						GMenu* _tmp53_;
						GMenuItem* _tmp54_;
						_tmp42_ = item;
						g_menu_item_set_detailed_action (_tmp42_, "indicator.item-enabled");
						_tmp43_ = item;
						g_menu_item_set_attribute (_tmp43_, "x-ayatana-type", "s", "org.ayatana.indicator.basic", NULL);
						_tmp44_ = item;
						g_menu_item_set_attribute (_tmp44_, "x-ayatana-use-markup", "b", TRUE, NULL);
						_tmp45_ = item;
						_tmp46_ = device;
						_tmp47_ = device_get_name (_tmp46_);
						_tmp48_ = _tmp47_;
						_tmp49_ = g_strconcat ("<b>", _tmp48_, NULL);
						_tmp50_ = _tmp49_;
						_tmp51_ = g_strconcat (_tmp50_, "</b>", NULL);
						_tmp52_ = _tmp51_;
						g_menu_item_set_label (_tmp45_, _tmp52_);
						_g_free0 (_tmp52_);
						_g_free0 (_tmp50_);
						_tmp53_ = self->priv->device_section;
						_tmp54_ = item;
						g_menu_append_item (_tmp53_, _tmp54_);
						{
							gint nItem = 0;
							nItem = 0;
							{
								gboolean _tmp55_ = FALSE;
								_tmp55_ = TRUE;
								while (TRUE) {
									GMenuItem* pItem = NULL;
									GMenu* _tmp57_;
									GMenuItem* _tmp58_;
									GMenu* _tmp59_;
									GMenuItem* _tmp60_;
									if (!_tmp55_) {
										gint _tmp56_;
										_tmp56_ = nItem;
										nItem = _tmp56_ + 1;
									}
									_tmp55_ = FALSE;
									if (!(nItem < nItems)) {
										break;
									}
									_tmp57_ = submenu;
									_tmp58_ = g_menu_item_new_from_model ((GMenuModel*) _tmp57_, nItem);
									pItem = _tmp58_;
									_tmp59_ = self->priv->device_section;
									_tmp60_ = pItem;
									g_menu_append_item (_tmp59_, _tmp60_);
									_g_object_unref0 (pItem);
								}
							}
						}
					}
				}
				_g_object_unref0 (item);
				_g_object_unref0 (submenu);
			}
		}
		(device_collection == NULL) ? NULL : (device_collection = (g_list_free (device_collection), NULL));
	}
}

static void
desktop_build_menu (Desktop* self)
{
	GMenu* section = NULL;
	GMenuItem* item = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp1_;
	GMenuItem* _tmp2_;
	GMenuItem* _tmp3_;
	GMenuItem* _tmp4_;
	GMenu* _tmp5_;
	GMenu* _tmp6_;
	GMenu* _tmp7_;
	GMenu* _tmp8_;
	GMenu* _tmp9_;
	GMenu* _tmp10_;
	GMenu* _tmp11_;
	GMenu* _tmp12_;
	GMenu* _tmp13_;
	GMenu* _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_menu_new ();
	_g_object_unref0 (section);
	section = _tmp0_;
	_tmp1_ = section;
	_tmp2_ = profile_create_enabled_menuitem ((Profile*) self);
	_tmp3_ = _tmp2_;
	g_menu_append_item (_tmp1_, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = g_menu_item_new (_ ("Visible"), "indicator.desktop-discoverable(true)");
	_g_object_unref0 (item);
	item = _tmp4_;
	g_menu_item_set_attribute (item, "x-ayatana-type", "s", "org.ayatana.indicator.switch", NULL);
	_tmp5_ = section;
	g_menu_append_item (_tmp5_, item);
	_tmp6_ = ((Profile*) self)->menu;
	_tmp7_ = section;
	g_menu_append_section (_tmp6_, NULL, (GMenuModel*) _tmp7_);
	_tmp8_ = g_menu_new ();
	_g_object_unref0 (self->priv->device_section);
	self->priv->device_section = _tmp8_;
	desktop_rebuild_device_section (self);
	_tmp9_ = ((Profile*) self)->menu;
	_tmp10_ = self->priv->device_section;
	g_menu_append_section (_tmp9_, NULL, (GMenuModel*) _tmp10_);
	_tmp11_ = g_menu_new ();
	_g_object_unref0 (section);
	section = _tmp11_;
	_tmp12_ = section;
	g_menu_append (_tmp12_, _ ("Bluetooth Settings…"), "indicator.desktop-show-settings::bluetooth");
	_tmp13_ = ((Profile*) self)->menu;
	_tmp14_ = section;
	g_menu_append_section (_tmp13_, NULL, (GMenuModel*) _tmp14_);
	_g_object_unref0 (item);
	_g_object_unref0 (section);
}

static void
desktop_show_settings (Desktop* self,
                       const gchar* panel)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (panel != NULL);
	if (ayatana_common_utils_is_lomiri ()) {
		ayatana_common_utils_open_url ("settings:///system/bluetooth");
	} else {
		gboolean _tmp0_ = FALSE;
		if (ayatana_common_utils_is_unity ()) {
			_tmp0_ = ayatana_common_utils_have_program ("unity-control-center");
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			gchar* _tmp1_;
			gchar* _tmp2_;
			_tmp1_ = g_strconcat ("unity-control-center ", panel, NULL);
			_tmp2_ = _tmp1_;
			ayatana_common_utils_execute_command (_tmp2_);
			_g_free0 (_tmp2_);
		} else {
			gboolean _tmp3_ = FALSE;
			if (ayatana_common_utils_is_mate ()) {
				_tmp3_ = ayatana_common_utils_have_program ("blueman-manager");
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				ayatana_common_utils_execute_command ("blueman-manager");
			} else {
				gchar* _tmp4_;
				gchar* _tmp5_;
				_tmp4_ = g_strconcat ("gnome-control-center ", panel, NULL);
				_tmp5_ = _tmp4_;
				ayatana_common_utils_execute_command (_tmp5_);
				_g_free0 (_tmp5_);
			}
		}
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		Desktop* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->action);
		_g_object_unref0 (_data3_->bluetooth);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
__lambda4_ (Desktop* self,
            GSimpleAction* action,
            GVariant* param)
{
	g_return_if_fail (action != NULL);
	g_signal_emit_by_name (action, "change-state", param);
}

static void
___lambda4__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda4_ ((Desktop*) self, _sender, parameter);
}

static void
__lambda5_ (Block3Data* _data3_,
            GSimpleAction* action,
            GVariant* requestedValue)
{
	Desktop* self;
	self = _data3_->self;
	g_return_if_fail (action != NULL);
	bluetooth_try_set_discoverable (_data3_->bluetooth, g_variant_get_boolean (requestedValue));
}

static void
___lambda5__g_simple_action_change_state (GSimpleAction* _sender,
                                          GVariant* value,
                                          gpointer self)
{
	__lambda5_ (self, _sender, value);
}

static void
__lambda6_ (Block3Data* _data3_)
{
	Desktop* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	self = _data3_->self;
	_tmp0_ = bluetooth_get_discoverable (_data3_->bluetooth);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_new_boolean (_tmp1_);
	g_variant_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	g_simple_action_set_state (_data3_->action, _tmp3_);
	_g_variant_unref0 (_tmp3_);
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ (self);
}

static GAction*
desktop_create_discoverable_action (Desktop* self,
                                    Bluetooth* bluetooth)
{
	Block3Data* _data3_;
	Bluetooth* _tmp0_;
	const GVariantType* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GAction* _tmp8_;
	GAction* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (bluetooth != NULL, NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (bluetooth);
	_g_object_unref0 (_data3_->bluetooth);
	_data3_->bluetooth = _tmp0_;
	_tmp1_ = G_VARIANT_TYPE_BOOLEAN;
	_tmp2_ = bluetooth_get_discoverable (_data3_->bluetooth);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_variant_new_boolean (_tmp3_);
	g_variant_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_simple_action_new_stateful ("desktop-discoverable", _tmp1_, _tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	_data3_->action = _tmp7_;
	g_signal_connect_object (_data3_->action, "activate", (GCallback) ___lambda4__g_simple_action_activate, self, 0);
	g_signal_connect_data (_data3_->action, "change-state", (GCallback) ___lambda5__g_simple_action_change_state, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	g_signal_connect_data ((GObject*) _data3_->bluetooth, "notify::discoverable", (GCallback) ___lambda6__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp8_ = _g_object_ref0 ((GAction*) _data3_->action);
	result = _tmp8_;
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return result;
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		Desktop* self;
		self = _data4_->self;
		_g_free0 (_data4_->uri);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
__lambda8_ (Block4Data* _data4_,
            GObject* obj,
            GAsyncResult* res)
{
	Desktop* self;
	GError* _inner_error0_ = NULL;
	self = _data4_->self;
	g_return_if_fail (res != NULL);
	{
		g_app_info_launch_default_for_uri (_data4_->uri, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = string_to_string (_data4_->uri);
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		_tmp3_ = string_to_string (_tmp2_);
		_tmp4_ = g_strconcat ("unable to launch '", _tmp0_, "': ", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		g_warning ("desktop.vala:305: %s", _tmp5_);
		_g_free0 (_tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda8__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
	__lambda8_ (self, source_object, res);
	block4_data_unref (self);
}

static void
__lambda7_ (Desktop* self,
            GSimpleAction* action,
            GVariant* address)
{
	Block4Data* _data4_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* file = NULL;
	GFile* _tmp3_;
	g_return_if_fail (action != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = g_variant_get_string (address, NULL);
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = g_strconcat ("obex://[", _tmp1_, "]/", NULL);
	_data4_->uri = _tmp2_;
	_tmp3_ = g_file_new_for_uri (_data4_->uri);
	file = _tmp3_;
	g_file_mount_enclosing_volume (file, G_MOUNT_MOUNT_NONE, NULL, NULL, ___lambda8__gasync_ready_callback, block4_data_ref (_data4_));
	_g_object_unref0 (file);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static void
___lambda7__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda7_ ((Desktop*) self, _sender, parameter);
}

static GAction*
desktop_create_browse_files_action (Desktop* self)
{
	GSimpleAction* action = NULL;
	const GVariantType* _tmp0_;
	GSimpleAction* _tmp1_;
	GAction* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = G_VARIANT_TYPE_STRING;
	_tmp1_ = g_simple_action_new ("desktop-browse-files", _tmp0_);
	action = _tmp1_;
	g_signal_connect_object (action, "activate", (GCallback) ___lambda7__g_simple_action_activate, self, 0);
	result = (GAction*) action;
	return result;
}

static void
__lambda9_ (Desktop* self,
            GSimpleAction* action,
            GVariant* address)
{
	gchar* cmd = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (action != NULL);
	_tmp0_ = g_variant_get_string (address, NULL);
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = g_strconcat ("bluetooth-sendto --device=", _tmp1_, NULL);
	cmd = _tmp2_;
	profile_spawn_command_line_async ((Profile*) self, cmd);
	_g_free0 (cmd);
}

static void
___lambda9__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda9_ ((Desktop*) self, _sender, parameter);
}

static GAction*
desktop_create_send_file_action (Desktop* self)
{
	GSimpleAction* action = NULL;
	const GVariantType* _tmp0_;
	GSimpleAction* _tmp1_;
	GAction* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = G_VARIANT_TYPE_STRING;
	_tmp1_ = g_simple_action_new ("desktop-send-file", _tmp0_);
	action = _tmp1_;
	g_signal_connect_object (action, "activate", (GCallback) ___lambda9__g_simple_action_activate, self, 0);
	result = (GAction*) action;
	return result;
}

static void
__lambda10_ (Desktop* self,
             GSimpleAction* action,
             GVariant* panel)
{
	const gchar* _tmp0_;
	g_return_if_fail (action != NULL);
	_tmp0_ = g_variant_get_string (panel, NULL);
	desktop_show_settings (self, _tmp0_);
}

static void
___lambda10__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
	__lambda10_ ((Desktop*) self, _sender, parameter);
}

static GAction*
desktop_create_show_settings_action (Desktop* self)
{
	GSimpleAction* action = NULL;
	const GVariantType* _tmp0_;
	GSimpleAction* _tmp1_;
	GAction* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = G_VARIANT_TYPE_STRING;
	_tmp1_ = g_simple_action_new ("desktop-show-settings", _tmp0_);
	action = _tmp1_;
	g_signal_connect_object (action, "activate", (GCallback) ___lambda10__g_simple_action_activate, self, 0);
	result = (GAction*) action;
	return result;
}

static void
desktop_class_init (DesktopClass * klass,
                    gpointer klass_data)
{
	desktop_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Desktop_private_offset);
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) desktop_real_dispose;
	G_OBJECT_CLASS (klass)->finalize = desktop_finalize;
}

static void
desktop_instance_init (Desktop * self,
                       gpointer klass)
{
	self->priv = desktop_get_instance_private (self);
	self->priv->idle_rebuild_id = (guint) 0;
}

static void
desktop_finalize (GObject * obj)
{
	Desktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DESKTOP, Desktop);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->action_group);
	_g_object_unref0 (self->priv->device_section);
	_g_hash_table_unref0 (self->priv->connect_actions);
	G_OBJECT_CLASS (desktop_parent_class)->finalize (obj);
}

static GType
desktop_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DesktopClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) desktop_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Desktop), 0, (GInstanceInitFunc) desktop_instance_init, NULL };
	GType desktop_type_id;
	desktop_type_id = g_type_register_static (TYPE_PROFILE, "Desktop", &g_define_type_info, 0);
	Desktop_private_offset = g_type_add_instance_private (desktop_type_id, sizeof (DesktopPrivate));
	return desktop_type_id;
}

GType
desktop_get_type (void)
{
	static volatile gsize desktop_type_id__once = 0;
	if (g_once_init_enter (&desktop_type_id__once)) {
		GType desktop_type_id;
		desktop_type_id = desktop_get_type_once ();
		g_once_init_leave (&desktop_type_id__once, desktop_type_id);
	}
	return desktop_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

