/* device.c generated by valac 0.56.12, the Vala compiler
 * generated from device.vala, do not modify */

/*
 * Copyright 2013 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *   Charles Kerr <charles.kerr@canonical.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _DevicePrivate DevicePrivate;
typedef enum  {
	DEVICE_TYPE_OTHER,
	DEVICE_TYPE_COMPUTER,
	DEVICE_TYPE_PHONE,
	DEVICE_TYPE_MODEM,
	DEVICE_TYPE_NETWORK,
	DEVICE_TYPE_HEADSET,
	DEVICE_TYPE_HEADPHONES,
	DEVICE_TYPE_VIDEO,
	DEVICE_TYPE_OTHER_AUDIO,
	DEVICE_TYPE_JOYPAD,
	DEVICE_TYPE_KEYPAD,
	DEVICE_TYPE_KEYBOARD,
	DEVICE_TYPE_TABLET,
	DEVICE_TYPE_MOUSE,
	DEVICE_TYPE_PRINTER,
	DEVICE_TYPE_CAMERA
} DeviceType;

#define DEVICE_TYPE_TYPE (device_type_get_type ())
enum  {
	DEVICE_0_PROPERTY,
	DEVICE_DEVICE_TYPE_PROPERTY,
	DEVICE_ID_PROPERTY,
	DEVICE_NAME_PROPERTY,
	DEVICE_ADDRESS_PROPERTY,
	DEVICE_ICON_PROPERTY,
	DEVICE_IS_CONNECTABLE_PROPERTY,
	DEVICE_IS_CONNECTED_PROPERTY,
	DEVICE_SUPPORTS_BROWSING_PROPERTY,
	DEVICE_SUPPORTS_FILE_TRANSFER_PROPERTY,
	DEVICE_NUM_PROPERTIES
};
static GParamSpec* device_properties[DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

struct _DevicePrivate {
	DeviceType _device_type;
	guint _id;
	gchar* _name;
	gchar* _address;
	GIcon* _icon;
	gboolean _is_connectable;
	gboolean _is_connected;
	gboolean _supports_browsing;
	gboolean _supports_file_transfer;
};

static gint Device_private_offset;
static gpointer device_parent_class = NULL;

VALA_EXTERN GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
VALA_EXTERN GType device_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* device_print (Device* self);
VALA_EXTERN guint device_get_id (Device* self);
VALA_EXTERN const gchar* device_get_name (Device* self);
VALA_EXTERN const gchar* device_get_address (Device* self);
VALA_EXTERN GIcon* device_get_icon (Device* self);
VALA_EXTERN DeviceType device_get_device_type (Device* self);
VALA_EXTERN gboolean device_get_is_connectable (Device* self);
VALA_EXTERN gboolean device_get_is_connected (Device* self);
VALA_EXTERN gboolean device_get_supports_browsing (Device* self);
VALA_EXTERN gboolean device_get_supports_file_transfer (Device* self);
VALA_EXTERN Device* device_new (guint id,
                    DeviceType device_type,
                    const gchar* name,
                    const gchar* address,
                    GIcon* icon,
                    gboolean is_connectable,
                    gboolean is_connected,
                    gboolean supports_browsing,
                    gboolean supports_file_transfer);
VALA_EXTERN Device* device_construct (GType object_type,
                          guint id,
                          DeviceType device_type,
                          const gchar* name,
                          const gchar* address,
                          GIcon* icon,
                          gboolean is_connectable,
                          gboolean is_connected,
                          gboolean supports_browsing,
                          gboolean supports_file_transfer);
VALA_EXTERN DeviceType device_class_to_device_type (guint32 c);
static void device_set_device_type (Device* self,
                             DeviceType value);
static void device_set_id (Device* self,
                    guint value);
static void device_set_name (Device* self,
                      const gchar* value);
static void device_set_address (Device* self,
                         const gchar* value);
static void device_set_icon (Device* self,
                      GIcon* value);
static void device_set_is_connectable (Device* self,
                                gboolean value);
static void device_set_is_connected (Device* self,
                              gboolean value);
static void device_set_supports_browsing (Device* self,
                                   gboolean value);
static void device_set_supports_file_transfer (Device* self,
                                        gboolean value);
static void device_finalize (GObject * obj);
static GType device_get_type_once (void);
static void _vala_device_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_device_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);

static inline gpointer
device_get_instance_private (Device* self)
{
	return G_STRUCT_MEMBER_P (self, Device_private_offset);
}

static GType
device_type_get_type_once (void)
{
	static const GEnumValue values[] = {{DEVICE_TYPE_OTHER, "DEVICE_TYPE_OTHER", "other"}, {DEVICE_TYPE_COMPUTER, "DEVICE_TYPE_COMPUTER", "computer"}, {DEVICE_TYPE_PHONE, "DEVICE_TYPE_PHONE", "phone"}, {DEVICE_TYPE_MODEM, "DEVICE_TYPE_MODEM", "modem"}, {DEVICE_TYPE_NETWORK, "DEVICE_TYPE_NETWORK", "network"}, {DEVICE_TYPE_HEADSET, "DEVICE_TYPE_HEADSET", "headset"}, {DEVICE_TYPE_HEADPHONES, "DEVICE_TYPE_HEADPHONES", "headphones"}, {DEVICE_TYPE_VIDEO, "DEVICE_TYPE_VIDEO", "video"}, {DEVICE_TYPE_OTHER_AUDIO, "DEVICE_TYPE_OTHER_AUDIO", "other-audio"}, {DEVICE_TYPE_JOYPAD, "DEVICE_TYPE_JOYPAD", "joypad"}, {DEVICE_TYPE_KEYPAD, "DEVICE_TYPE_KEYPAD", "keypad"}, {DEVICE_TYPE_KEYBOARD, "DEVICE_TYPE_KEYBOARD", "keyboard"}, {DEVICE_TYPE_TABLET, "DEVICE_TYPE_TABLET", "tablet"}, {DEVICE_TYPE_MOUSE, "DEVICE_TYPE_MOUSE", "mouse"}, {DEVICE_TYPE_PRINTER, "DEVICE_TYPE_PRINTER", "printer"}, {DEVICE_TYPE_CAMERA, "DEVICE_TYPE_CAMERA", "camera"}, {0, NULL, NULL}};
	GType device_type_type_id;
	device_type_type_id = g_enum_register_static ("DeviceType", values);
	return device_type_type_id;
}

GType
device_type_get_type (void)
{
	static volatile gsize device_type_type_id__once = 0;
	if (g_once_init_enter (&device_type_type_id__once)) {
		GType device_type_type_id;
		device_type_type_id = device_type_get_type_once ();
		g_once_init_leave (&device_type_type_id__once, device_type_type_id);
	}
	return device_type_type_id__once;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

gchar*
device_print (Device* self)
{
	guint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GIcon* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	DeviceType _tmp11_;
	GEnumValue* _tmp12_;
	gboolean _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gboolean _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gboolean _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gboolean _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_id;
	_tmp1_ = g_strdup_printf ("%u", _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_name;
	_tmp4_ = string_to_string (_tmp3_);
	_tmp5_ = self->priv->_address;
	_tmp6_ = string_to_string (_tmp5_);
	_tmp7_ = self->priv->_icon;
	_tmp8_ = g_icon_to_string (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = string_to_string (_tmp9_);
	_tmp11_ = self->priv->_device_type;
	_tmp12_ = g_enum_get_value (g_type_class_ref (DEVICE_TYPE_TYPE), _tmp11_);
	_tmp13_ = self->priv->_is_connectable;
	_tmp14_ = bool_to_string (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = self->priv->_is_connected;
	_tmp17_ = bool_to_string (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = self->priv->_supports_browsing;
	_tmp20_ = bool_to_string (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = self->priv->_supports_file_transfer;
	_tmp23_ = bool_to_string (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_strconcat ("{id:", _tmp2_, ", name:", _tmp4_, ", address:", _tmp6_, ", icon:", _tmp10_, ", device_type:", (_tmp12_ != NULL) ? _tmp12_->value_name : NULL, ", is_connectable:", _tmp15_, ", is_connected:", _tmp18_, ", supports_browsing:", _tmp21_, ", supports_file_transfer:", _tmp24_, "}", NULL);
	_tmp26_ = _tmp25_;
	_g_free0 (_tmp24_);
	_g_free0 (_tmp21_);
	_g_free0 (_tmp18_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp2_);
	result = _tmp26_;
	return result;
}

Device*
device_construct (GType object_type,
                  guint id,
                  DeviceType device_type,
                  const gchar* name,
                  const gchar* address,
                  GIcon* icon,
                  gboolean is_connectable,
                  gboolean is_connected,
                  gboolean supports_browsing,
                  gboolean supports_file_transfer)
{
	Device * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (address != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	self = (Device*) g_object_new (object_type, "id", id, "device-type", device_type, "name", name, "address", address, "icon", icon, "is-connectable", is_connectable, "is-connected", is_connected, "supports-browsing", supports_browsing, "supports-file-transfer", supports_file_transfer, NULL);
	return self;
}

Device*
device_new (guint id,
            DeviceType device_type,
            const gchar* name,
            const gchar* address,
            GIcon* icon,
            gboolean is_connectable,
            gboolean is_connected,
            gboolean supports_browsing,
            gboolean supports_file_transfer)
{
	return device_construct (TYPE_DEVICE, id, device_type, name, address, icon, is_connectable, is_connected, supports_browsing, supports_file_transfer);
}

DeviceType
device_class_to_device_type (guint32 c)
{
	DeviceType result;
	switch ((c & 0x1f00) >> 8) {
		case 0x01:
		{
			result = DEVICE_TYPE_COMPUTER;
			return result;
		}
		case 0x02:
		{
			switch ((c & 0xfc) >> 2) {
				case 0x01:
				case 0x02:
				case 0x03:
				case 0x05:
				{
					result = DEVICE_TYPE_PHONE;
					return result;
				}
				case 0x04:
				{
					result = DEVICE_TYPE_MODEM;
					return result;
				}
				default:
				break;
			}
			break;
		}
		case 0x03:
		{
			result = DEVICE_TYPE_NETWORK;
			return result;
		}
		case 0x04:
		{
			switch ((c & 0xfc) >> 2) {
				case 0x01:
				case 0x02:
				{
					result = DEVICE_TYPE_HEADSET;
					return result;
				}
				case 0x06:
				{
					result = DEVICE_TYPE_HEADPHONES;
					return result;
				}
				case 0x0b:
				case 0x0c:
				case 0x0d:
				{
					result = DEVICE_TYPE_VIDEO;
					return result;
				}
				default:
				{
					result = DEVICE_TYPE_OTHER_AUDIO;
					return result;
				}
			}
		}
		case 0x05:
		{
			switch ((c & 0xc0) >> 6) {
				case 0x00:
				{
					switch ((c & 0x1e) >> 2) {
						case 0x01:
						case 0x02:
						{
							result = DEVICE_TYPE_JOYPAD;
							return result;
						}
						default:
						break;
					}
					break;
				}
				case 0x01:
				{
					result = DEVICE_TYPE_KEYBOARD;
					return result;
				}
				case 0x02:
				{
					switch ((c & 0x1e) >> 2) {
						case 0x05:
						{
							result = DEVICE_TYPE_TABLET;
							return result;
						}
						default:
						{
							result = DEVICE_TYPE_MOUSE;
							return result;
						}
					}
				}
				default:
				break;
			}
			break;
		}
		case 0x06:
		{
			if ((c & 0x80) != ((guint32) 0)) {
				result = DEVICE_TYPE_PRINTER;
				return result;
			}
			if ((c & 0x20) != ((guint32) 0)) {
				result = DEVICE_TYPE_CAMERA;
				return result;
			}
			break;
		}
		default:
		break;
	}
	result = 0;
	return result;
}

DeviceType
device_get_device_type (Device* self)
{
	DeviceType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_device_type;
	return result;
}

static void
device_set_device_type (Device* self,
                        DeviceType value)
{
	DeviceType old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_device_type (self);
	if (old_value != value) {
		self->priv->_device_type = value;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_DEVICE_TYPE_PROPERTY]);
	}
}

guint
device_get_id (Device* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_id;
	return result;
}

static void
device_set_id (Device* self,
               guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_id (self);
	if (old_value != value) {
		self->priv->_id = value;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_ID_PROPERTY]);
	}
}

const gchar*
device_get_name (Device* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
device_set_name (Device* self,
                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_NAME_PROPERTY]);
	}
}

const gchar*
device_get_address (Device* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_address;
	result = _tmp0_;
	return result;
}

static void
device_set_address (Device* self,
                    const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_address (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_address);
		self->priv->_address = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_ADDRESS_PROPERTY]);
	}
}

GIcon*
device_get_icon (Device* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
device_set_icon (Device* self,
                 GIcon* value)
{
	GIcon* old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_icon (self);
	if (old_value != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_icon);
		self->priv->_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_ICON_PROPERTY]);
	}
}

gboolean
device_get_is_connectable (Device* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_connectable;
	return result;
}

static void
device_set_is_connectable (Device* self,
                           gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_is_connectable (self);
	if (old_value != value) {
		self->priv->_is_connectable = value;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_IS_CONNECTABLE_PROPERTY]);
	}
}

gboolean
device_get_is_connected (Device* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_connected;
	return result;
}

static void
device_set_is_connected (Device* self,
                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_is_connected (self);
	if (old_value != value) {
		self->priv->_is_connected = value;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_IS_CONNECTED_PROPERTY]);
	}
}

gboolean
device_get_supports_browsing (Device* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_supports_browsing;
	return result;
}

static void
device_set_supports_browsing (Device* self,
                              gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_supports_browsing (self);
	if (old_value != value) {
		self->priv->_supports_browsing = value;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_SUPPORTS_BROWSING_PROPERTY]);
	}
}

gboolean
device_get_supports_file_transfer (Device* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_supports_file_transfer;
	return result;
}

static void
device_set_supports_file_transfer (Device* self,
                                   gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = device_get_supports_file_transfer (self);
	if (old_value != value) {
		self->priv->_supports_file_transfer = value;
		g_object_notify_by_pspec ((GObject *) self, device_properties[DEVICE_SUPPORTS_FILE_TRANSFER_PROPERTY]);
	}
}

static void
device_class_init (DeviceClass * klass,
                   gpointer klass_data)
{
	device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Device_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_device_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_device_set_property;
	G_OBJECT_CLASS (klass)->finalize = device_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_DEVICE_TYPE_PROPERTY, device_properties[DEVICE_DEVICE_TYPE_PROPERTY] = g_param_spec_enum ("device-type", "device-type", "device-type", DEVICE_TYPE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ID_PROPERTY, device_properties[DEVICE_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_NAME_PROPERTY, device_properties[DEVICE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ADDRESS_PROPERTY, device_properties[DEVICE_ADDRESS_PROPERTY] = g_param_spec_string ("address", "address", "address", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_ICON_PROPERTY, device_properties[DEVICE_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_IS_CONNECTABLE_PROPERTY, device_properties[DEVICE_IS_CONNECTABLE_PROPERTY] = g_param_spec_boolean ("is-connectable", "is-connectable", "is-connectable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_IS_CONNECTED_PROPERTY, device_properties[DEVICE_IS_CONNECTED_PROPERTY] = g_param_spec_boolean ("is-connected", "is-connected", "is-connected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SUPPORTS_BROWSING_PROPERTY, device_properties[DEVICE_SUPPORTS_BROWSING_PROPERTY] = g_param_spec_boolean ("supports-browsing", "supports-browsing", "supports-browsing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SUPPORTS_FILE_TRANSFER_PROPERTY, device_properties[DEVICE_SUPPORTS_FILE_TRANSFER_PROPERTY] = g_param_spec_boolean ("supports-file-transfer", "supports-file-transfer", "supports-file-transfer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
device_instance_init (Device * self,
                      gpointer klass)
{
	self->priv = device_get_instance_private (self);
}

static void
device_finalize (GObject * obj)
{
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE, Device);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_address);
	_g_object_unref0 (self->priv->_icon);
	G_OBJECT_CLASS (device_parent_class)->finalize (obj);
}

static GType
device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Device), 0, (GInstanceInitFunc) device_instance_init, NULL };
	GType device_type_id;
	device_type_id = g_type_register_static (G_TYPE_OBJECT, "Device", &g_define_type_info, 0);
	Device_private_offset = g_type_add_instance_private (device_type_id, sizeof (DevicePrivate));
	return device_type_id;
}

GType
device_get_type (void)
{
	static volatile gsize device_type_id__once = 0;
	if (g_once_init_enter (&device_type_id__once)) {
		GType device_type_id;
		device_type_id = device_get_type_once ();
		g_once_init_leave (&device_type_id__once, device_type_id);
	}
	return device_type_id__once;
}

static void
_vala_device_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE, Device);
	switch (property_id) {
		case DEVICE_DEVICE_TYPE_PROPERTY:
		g_value_set_enum (value, device_get_device_type (self));
		break;
		case DEVICE_ID_PROPERTY:
		g_value_set_uint (value, device_get_id (self));
		break;
		case DEVICE_NAME_PROPERTY:
		g_value_set_string (value, device_get_name (self));
		break;
		case DEVICE_ADDRESS_PROPERTY:
		g_value_set_string (value, device_get_address (self));
		break;
		case DEVICE_ICON_PROPERTY:
		g_value_set_object (value, device_get_icon (self));
		break;
		case DEVICE_IS_CONNECTABLE_PROPERTY:
		g_value_set_boolean (value, device_get_is_connectable (self));
		break;
		case DEVICE_IS_CONNECTED_PROPERTY:
		g_value_set_boolean (value, device_get_is_connected (self));
		break;
		case DEVICE_SUPPORTS_BROWSING_PROPERTY:
		g_value_set_boolean (value, device_get_supports_browsing (self));
		break;
		case DEVICE_SUPPORTS_FILE_TRANSFER_PROPERTY:
		g_value_set_boolean (value, device_get_supports_file_transfer (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_device_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE, Device);
	switch (property_id) {
		case DEVICE_DEVICE_TYPE_PROPERTY:
		device_set_device_type (self, g_value_get_enum (value));
		break;
		case DEVICE_ID_PROPERTY:
		device_set_id (self, g_value_get_uint (value));
		break;
		case DEVICE_NAME_PROPERTY:
		device_set_name (self, g_value_get_string (value));
		break;
		case DEVICE_ADDRESS_PROPERTY:
		device_set_address (self, g_value_get_string (value));
		break;
		case DEVICE_ICON_PROPERTY:
		device_set_icon (self, g_value_get_object (value));
		break;
		case DEVICE_IS_CONNECTABLE_PROPERTY:
		device_set_is_connectable (self, g_value_get_boolean (value));
		break;
		case DEVICE_IS_CONNECTED_PROPERTY:
		device_set_is_connected (self, g_value_get_boolean (value));
		break;
		case DEVICE_SUPPORTS_BROWSING_PROPERTY:
		device_set_supports_browsing (self, g_value_get_boolean (value));
		break;
		case DEVICE_SUPPORTS_FILE_TRANSFER_PROPERTY:
		device_set_supports_file_transfer (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

