/* phone.c generated by valac 0.56.12, the Vala compiler
 * generated from phone.vala, do not modify */

/*
 * Copyright 2013 Canonical Ltd.
 * Copyright 2021 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *   Charles Kerr <charles.kerr@canonical.com>
 *   Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <ayatana/common/utils.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PROFILE (profile_get_type ())
#define PROFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROFILE, Profile))
#define PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROFILE, ProfileClass))
#define IS_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROFILE))
#define IS_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROFILE))
#define PROFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROFILE, ProfileClass))

typedef struct _Profile Profile;
typedef struct _ProfileClass ProfileClass;
typedef struct _ProfilePrivate ProfilePrivate;

#define TYPE_BLUETOOTH (bluetooth_get_type ())
#define BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLUETOOTH, Bluetooth))
#define IS_BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLUETOOTH))
#define BLUETOOTH_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BLUETOOTH, BluetoothIface))

typedef struct _Bluetooth Bluetooth;
typedef struct _BluetoothIface BluetoothIface;

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;

#define TYPE_PHONE (phone_get_type ())
#define PHONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHONE, Phone))
#define PHONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHONE, PhoneClass))
#define IS_PHONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHONE))
#define IS_PHONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHONE))
#define PHONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHONE, PhoneClass))

typedef struct _Phone Phone;
typedef struct _PhoneClass PhoneClass;
typedef struct _PhonePrivate PhonePrivate;
enum  {
	PHONE_0_PROPERTY,
	PHONE_NUM_PROPERTIES
};
static GParamSpec* phone_properties[PHONE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BluetoothIface {
	GTypeInterface parent_iface;
	void (*try_set_enabled) (Bluetooth* self, gboolean b);
	void (*try_set_discoverable) (Bluetooth* self, gboolean discoverable);
	GList* (*get_devices) (Bluetooth* self);
	void (*set_device_connected) (Bluetooth* self, guint device_key, gboolean connected);
	gboolean (*get_supported) (Bluetooth* self);
	void (*set_supported) (Bluetooth* self, gboolean value);
	gboolean (*get_enabled) (Bluetooth* self);
	void (*set_enabled) (Bluetooth* self, gboolean value);
	gboolean (*get_connected) (Bluetooth* self);
	void (*set_connected) (Bluetooth* self, gboolean value);
	gboolean (*get_discoverable) (Bluetooth* self);
	void (*set_discoverable) (Bluetooth* self, gboolean value);
};

struct _Profile {
	GObject parent_instance;
	ProfilePrivate * priv;
	Bluetooth* bluetooth;
	gchar* profile_name;
	GMenu* root;
	GMenu* menu;
	GSimpleAction* root_action;
};

struct _ProfileClass {
	GObjectClass parent_class;
};

struct _Phone {
	Profile parent_instance;
	PhonePrivate * priv;
};

struct _PhoneClass {
	ProfileClass parent_class;
};

struct _PhonePrivate {
	GSimpleActionGroup* action_group;
};

static gint Phone_private_offset;
static gpointer phone_parent_class = NULL;

VALA_EXTERN GType profile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Profile, g_object_unref)
VALA_EXTERN GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
VALA_EXTERN GType bluetooth_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bluetooth, g_object_unref)
VALA_EXTERN GType phone_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Phone, g_object_unref)
VALA_EXTERN Phone* phone_new (Bluetooth* bluetooth,
                  GSimpleActionGroup* action_group);
VALA_EXTERN Phone* phone_construct (GType object_type,
                        Bluetooth* bluetooth,
                        GSimpleActionGroup* action_group);
VALA_EXTERN Profile* profile_new (Bluetooth* bluetooth,
                      const gchar* profile_name);
VALA_EXTERN Profile* profile_construct (GType object_type,
                            Bluetooth* bluetooth,
                            const gchar* profile_name);
static void _vala_array_add1 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
VALA_EXTERN GAction* profile_create_supported_action (Profile* self,
                                          Bluetooth* bluetooth);
static void _vala_array_add2 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
VALA_EXTERN GAction* profile_create_enabled_action (Profile* self,
                                        Bluetooth* bluetooth);
static void _vala_array_add3 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
static GAction* phone_create_settings_action (Phone* self);
static void _vala_array_add4 (GAction** * array,
                       gint* length,
                       gint* size,
                       GAction* value);
VALA_EXTERN GMenuItem* profile_create_enabled_menuitem (Profile* self);
static void __lambda5_ (Phone* self);
static void phone_update_visibility (Phone* self);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda6_ (Phone* self);
VALA_EXTERN void profile_update_root_action_state (Profile* self);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
VALA_EXTERN gboolean bluetooth_get_enabled (Bluetooth* self);
VALA_EXTERN void profile_set_visible (Profile* self,
                          gboolean value);
static void phone_show_settings (Phone* self,
                          const gchar* panel);
static void __lambda4_ (Phone* self,
                 GSimpleAction* action,
                 GVariant* panel);
static void ___lambda4__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
static void phone_finalize (GObject * obj);
static GType phone_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
phone_get_instance_private (Phone* self)
{
	return G_STRUCT_MEMBER_P (self, Phone_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_array_add1 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add2 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add3 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add4 (GAction** * array,
                  gint* length,
                  gint* size,
                  GAction* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GAction*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
__lambda5_ (Phone* self)
{
	phone_update_visibility (self);
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda5_ ((Phone*) self);
}

static void
__lambda6_ (Phone* self)
{
	profile_update_root_action_state ((Profile*) self);
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ ((Phone*) self);
}

Phone*
phone_construct (GType object_type,
                 Bluetooth* bluetooth,
                 GSimpleActionGroup* action_group)
{
	Phone * self = NULL;
	static const char profile_name[] = "phone";
	Bluetooth* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction** actions = NULL;
	GAction** _tmp2_;
	gint actions_length1;
	gint _actions_size_;
	GSimpleAction* _tmp3_;
	GAction* _tmp4_;
	GAction* _tmp5_;
	GAction* _tmp6_;
	GAction* _tmp7_;
	GAction** _tmp8_;
	gint _tmp8__length1;
	GMenu* section = NULL;
	GMenu* _tmp11_;
	GMenuItem* _tmp12_;
	GMenuItem* _tmp13_;
	GMenu* _tmp14_;
	g_return_val_if_fail (bluetooth != NULL, NULL);
	g_return_val_if_fail (action_group != NULL, NULL);
	self = (Phone*) profile_construct (object_type, bluetooth, profile_name);
	_tmp0_ = _g_object_ref0 (bluetooth);
	_g_object_unref0 (((Profile*) self)->bluetooth);
	((Profile*) self)->bluetooth = _tmp0_;
	_tmp1_ = _g_object_ref0 (action_group);
	_g_object_unref0 (self->priv->action_group);
	self->priv->action_group = _tmp1_;
	_tmp2_ = g_new0 (GAction*, 0 + 1);
	actions = _tmp2_;
	actions_length1 = 0;
	_actions_size_ = actions_length1;
	_tmp3_ = ((Profile*) self)->root_action;
	_tmp4_ = _g_object_ref0 ((GAction*) _tmp3_);
	_vala_array_add1 (&actions, &actions_length1, &_actions_size_, _tmp4_);
	_tmp5_ = profile_create_supported_action ((Profile*) self, bluetooth);
	_vala_array_add2 (&actions, &actions_length1, &_actions_size_, _tmp5_);
	_tmp6_ = profile_create_enabled_action ((Profile*) self, bluetooth);
	_vala_array_add3 (&actions, &actions_length1, &_actions_size_, _tmp6_);
	_tmp7_ = phone_create_settings_action (self);
	_vala_array_add4 (&actions, &actions_length1, &_actions_size_, _tmp7_);
	_tmp8_ = actions;
	_tmp8__length1 = actions_length1;
	{
		GAction** a_collection = NULL;
		gint a_collection_length1 = 0;
		gint _a_collection_size_ = 0;
		gint a_it = 0;
		a_collection = _tmp8_;
		a_collection_length1 = _tmp8__length1;
		for (a_it = 0; a_it < a_collection_length1; a_it = a_it + 1) {
			GAction* _tmp9_;
			GAction* a = NULL;
			_tmp9_ = _g_object_ref0 (a_collection[a_it]);
			a = _tmp9_;
			{
				GAction* _tmp10_;
				_tmp10_ = a;
				g_action_map_add_action ((GActionMap*) action_group, _tmp10_);
				_g_object_unref0 (a);
			}
		}
	}
	_tmp11_ = g_menu_new ();
	section = _tmp11_;
	_tmp12_ = profile_create_enabled_menuitem ((Profile*) self);
	_tmp13_ = _tmp12_;
	g_menu_append_item (section, _tmp13_);
	_g_object_unref0 (_tmp13_);
	g_menu_append (section, _ ("Bluetooth settings…"), "indicator.phone-show-settings::bluetooth");
	_tmp14_ = ((Profile*) self)->menu;
	g_menu_append_section (_tmp14_, NULL, (GMenuModel*) section);
	g_signal_connect_object ((GObject*) bluetooth, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
	phone_update_visibility (self);
	g_signal_connect_object ((GObject*) bluetooth, "notify", (GCallback) ___lambda6__g_object_notify, self, 0);
	_g_object_unref0 (section);
	actions = (_vala_array_free (actions, actions_length1, (GDestroyNotify) g_object_unref), NULL);
	return self;
}

Phone*
phone_new (Bluetooth* bluetooth,
           GSimpleActionGroup* action_group)
{
	return phone_construct (TYPE_PHONE, bluetooth, action_group);
}

static void
phone_update_visibility (Phone* self)
{
	Bluetooth* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = ((Profile*) self)->bluetooth;
	_tmp1_ = bluetooth_get_enabled (_tmp0_);
	_tmp2_ = _tmp1_;
	profile_set_visible ((Profile*) self, _tmp2_);
}

static void
phone_show_settings (Phone* self,
                     const gchar* panel)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (panel != NULL);
	ayatana_common_utils_open_url ("settings:///system/bluetooth");
}

static void
__lambda4_ (Phone* self,
            GSimpleAction* action,
            GVariant* panel)
{
	const gchar* _tmp0_;
	g_return_if_fail (action != NULL);
	_tmp0_ = g_variant_get_string (panel, NULL);
	phone_show_settings (self, _tmp0_);
}

static void
___lambda4__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda4_ ((Phone*) self, _sender, parameter);
}

static GAction*
phone_create_settings_action (Phone* self)
{
	GSimpleAction* action = NULL;
	const GVariantType* _tmp0_;
	GSimpleAction* _tmp1_;
	GAction* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = G_VARIANT_TYPE_STRING;
	_tmp1_ = g_simple_action_new ("phone-show-settings", _tmp0_);
	action = _tmp1_;
	g_signal_connect_object (action, "activate", (GCallback) ___lambda4__g_simple_action_activate, self, 0);
	result = (GAction*) action;
	return result;
}

static void
phone_class_init (PhoneClass * klass,
                  gpointer klass_data)
{
	phone_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Phone_private_offset);
	G_OBJECT_CLASS (klass)->finalize = phone_finalize;
}

static void
phone_instance_init (Phone * self,
                     gpointer klass)
{
	self->priv = phone_get_instance_private (self);
}

static void
phone_finalize (GObject * obj)
{
	Phone * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHONE, Phone);
	_g_object_unref0 (self->priv->action_group);
	G_OBJECT_CLASS (phone_parent_class)->finalize (obj);
}

static GType
phone_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PhoneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) phone_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Phone), 0, (GInstanceInitFunc) phone_instance_init, NULL };
	GType phone_type_id;
	phone_type_id = g_type_register_static (TYPE_PROFILE, "Phone", &g_define_type_info, 0);
	Phone_private_offset = g_type_add_instance_private (phone_type_id, sizeof (PhonePrivate));
	return phone_type_id;
}

GType
phone_get_type (void)
{
	static volatile gsize phone_type_id__once = 0;
	if (g_once_init_enter (&phone_type_id__once)) {
		GType phone_type_id;
		phone_type_id = phone_get_type_once ();
		g_once_init_leave (&phone_type_id__once, phone_type_id);
	}
	return phone_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

