/* profile.c generated by valac 0.56.12, the Vala compiler
 * generated from profile.vala, do not modify */

/*
 * Copyright 2013 Canonical Ltd.
 * Copyright 2022 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *   Charles Kerr <charles.kerr@canonical.com>
 *   Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PROFILE (profile_get_type ())
#define PROFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROFILE, Profile))
#define PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROFILE, ProfileClass))
#define IS_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROFILE))
#define IS_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROFILE))
#define PROFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROFILE, ProfileClass))

typedef struct _Profile Profile;
typedef struct _ProfileClass ProfileClass;
typedef struct _ProfilePrivate ProfilePrivate;

#define TYPE_BLUETOOTH (bluetooth_get_type ())
#define BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLUETOOTH, Bluetooth))
#define IS_BLUETOOTH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLUETOOTH))
#define BLUETOOTH_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BLUETOOTH, BluetoothIface))

typedef struct _Bluetooth Bluetooth;
typedef struct _BluetoothIface BluetoothIface;

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
enum  {
	PROFILE_0_PROPERTY,
	PROFILE_VISIBLE_PROPERTY,
	PROFILE_NUM_PROPERTIES
};
static GParamSpec* profile_properties[PROFILE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

struct _BluetoothIface {
	GTypeInterface parent_iface;
	void (*try_set_enabled) (Bluetooth* self, gboolean b);
	void (*try_set_discoverable) (Bluetooth* self, gboolean discoverable);
	GList* (*get_devices) (Bluetooth* self);
	void (*set_device_connected) (Bluetooth* self, guint device_key, gboolean connected);
	gboolean (*get_supported) (Bluetooth* self);
	void (*set_supported) (Bluetooth* self, gboolean value);
	gboolean (*get_enabled) (Bluetooth* self);
	void (*set_enabled) (Bluetooth* self, gboolean value);
	gboolean (*get_connected) (Bluetooth* self);
	void (*set_connected) (Bluetooth* self, gboolean value);
	gboolean (*get_discoverable) (Bluetooth* self);
	void (*set_discoverable) (Bluetooth* self, gboolean value);
};

struct _Profile {
	GObject parent_instance;
	ProfilePrivate * priv;
	Bluetooth* bluetooth;
	gchar* profile_name;
	GMenu* root;
	GMenu* menu;
	GSimpleAction* root_action;
};

struct _ProfileClass {
	GObjectClass parent_class;
};

struct _ProfilePrivate {
	guint menu_export_id;
	gboolean _visible;
};

struct _Block1Data {
	int _ref_count_;
	Profile* self;
	GSimpleAction* action;
	Bluetooth* bluetooth;
};

struct _Block2Data {
	int _ref_count_;
	Profile* self;
	GSimpleAction* action;
	Bluetooth* bluetooth;
};

static gint Profile_private_offset;
static gpointer profile_parent_class = NULL;

VALA_EXTERN GType profile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Profile, g_object_unref)
VALA_EXTERN GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
VALA_EXTERN GType bluetooth_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bluetooth, g_object_unref)
VALA_EXTERN Profile* profile_new (Bluetooth* bluetooth,
                      const gchar* profile_name);
VALA_EXTERN Profile* profile_construct (GType object_type,
                            Bluetooth* bluetooth,
                            const gchar* profile_name);
VALA_EXTERN GVariant* profile_action_state_for_root (Profile* self);
static void __lambda4_ (Profile* self);
VALA_EXTERN void profile_update_root_action_state (Profile* self);
static void ___lambda4__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda5_ (Profile* self);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda6_ (Profile* self);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GMenuItem* profile_create_root_menuitem (Profile* self);
VALA_EXTERN void profile_export_menu (Profile* self,
                          GDBusConnection* connection,
                          const gchar* object_path);
VALA_EXTERN void profile_unexport_menu (Profile* self,
                            GDBusConnection* connection);
VALA_EXTERN void profile_spawn_command_line_async (Profile* self,
                                       const gchar* command);
VALA_EXTERN GMenuItem* profile_create_enabled_menuitem (Profile* self);
VALA_EXTERN GAction* profile_create_supported_action (Profile* self,
                                          Bluetooth* bluetooth);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
VALA_EXTERN gboolean bluetooth_get_supported (Bluetooth* self);
static void __lambda7_ (Block1Data* _data1_);
static void ___lambda7__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
VALA_EXTERN GAction* profile_create_enabled_action (Profile* self,
                                        Bluetooth* bluetooth);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
VALA_EXTERN gboolean bluetooth_get_enabled (Bluetooth* self);
static void __lambda8_ (Profile* self,
                 GSimpleAction* action,
                 GVariant* param);
static void ___lambda8__g_simple_action_activate (GSimpleAction* _sender,
                                           GVariant* parameter,
                                           gpointer self);
static void __lambda9_ (Block2Data* _data2_,
                 GSimpleAction* action,
                 GVariant* requestedValue);
VALA_EXTERN void bluetooth_try_set_enabled (Bluetooth* self,
                                gboolean b);
static void ___lambda9__g_simple_action_change_state (GSimpleAction* _sender,
                                               GVariant* value,
                                               gpointer self);
static void __lambda10_ (Block2Data* _data2_);
static void ___lambda10__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
VALA_EXTERN gboolean bluetooth_get_connected (Bluetooth* self);
VALA_EXTERN gboolean profile_get_visible (Profile* self);
VALA_EXTERN void profile_set_visible (Profile* self,
                          gboolean value);
static void profile_finalize (GObject * obj);
static GType profile_get_type_once (void);
static void _vala_profile_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_profile_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);

static inline gpointer
profile_get_instance_private (Profile* self)
{
	return G_STRUCT_MEMBER_P (self, Profile_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
__lambda4_ (Profile* self)
{
	profile_update_root_action_state (self);
}

static void
___lambda4__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda4_ ((Profile*) self);
}

static void
__lambda5_ (Profile* self)
{
	profile_update_root_action_state (self);
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda5_ ((Profile*) self);
}

static void
__lambda6_ (Profile* self)
{
	profile_update_root_action_state (self);
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda6_ ((Profile*) self);
}

Profile*
profile_construct (GType object_type,
                   Bluetooth* bluetooth,
                   const gchar* profile_name)
{
	Profile * self = NULL;
	Bluetooth* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GSimpleAction* _tmp7_;
	GMenu* _tmp8_;
	GMenuItem* item = NULL;
	GMenuItem* _tmp9_;
	GMenu* _tmp10_;
	GMenu* _tmp11_;
	GMenu* _tmp12_;
	g_return_val_if_fail (bluetooth != NULL, NULL);
	g_return_val_if_fail (profile_name != NULL, NULL);
	self = (Profile*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (bluetooth);
	_g_object_unref0 (self->bluetooth);
	self->bluetooth = _tmp0_;
	_tmp1_ = g_strdup (profile_name);
	_g_free0 (self->profile_name);
	self->profile_name = _tmp1_;
	_tmp2_ = string_to_string (profile_name);
	_tmp3_ = g_strconcat ("root-", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = profile_action_state_for_root (self);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_simple_action_new_stateful (_tmp4_, NULL, _tmp6_);
	_g_object_unref0 (self->root_action);
	self->root_action = _tmp7_;
	_g_variant_unref0 (_tmp6_);
	_g_free0 (_tmp4_);
	g_signal_connect_object ((GObject*) self, "notify::visible", (GCallback) ___lambda4__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) bluetooth, "notify::enabled", (GCallback) ___lambda5__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) bluetooth, "notify::connected", (GCallback) ___lambda6__g_object_notify, self, 0);
	_tmp8_ = g_menu_new ();
	_g_object_unref0 (self->menu);
	self->menu = _tmp8_;
	_tmp9_ = profile_create_root_menuitem (self);
	item = _tmp9_;
	_tmp10_ = self->menu;
	g_menu_item_set_submenu (item, (GMenuModel*) _tmp10_);
	_tmp11_ = g_menu_new ();
	_g_object_unref0 (self->root);
	self->root = _tmp11_;
	_tmp12_ = self->root;
	g_menu_append_item (_tmp12_, item);
	_g_object_unref0 (item);
	return self;
}

Profile*
profile_new (Bluetooth* bluetooth,
             const gchar* profile_name)
{
	return profile_construct (TYPE_PROFILE, bluetooth, profile_name);
}

void
profile_export_menu (Profile* self,
                     GDBusConnection* connection,
                     const gchar* object_path)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (object_path != NULL);
	{
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		guint _tmp4_ = 0U;
		GMenu* _tmp5_;
		_tmp0_ = self->profile_name;
		_tmp1_ = string_to_string (_tmp0_);
		_tmp2_ = g_strconcat ("exporting menu '", _tmp1_, "'", NULL);
		_tmp3_ = _tmp2_;
		g_debug ("profile.vala:57: %s", _tmp3_);
		_g_free0 (_tmp3_);
		_tmp5_ = self->root;
		_tmp4_ = g_dbus_connection_export_menu_model (connection, object_path, (GMenuModel*) _tmp5_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		self->priv->menu_export_id = _tmp4_;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = string_to_string (object_path);
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = string_to_string (_tmp8_);
		_tmp10_ = g_strconcat ("Unable to export menu on ", _tmp6_, ": ", _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		g_critical ("profile.vala:62: %s", _tmp11_);
		_g_free0 (_tmp11_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

void
profile_unexport_menu (Profile* self,
                       GDBusConnection* connection)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	if (self->priv->menu_export_id != ((guint) 0)) {
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp0_ = self->profile_name;
		_tmp1_ = string_to_string (_tmp0_);
		_tmp2_ = g_strconcat ("unexporting menu '", _tmp1_, "'", NULL);
		_tmp3_ = _tmp2_;
		g_debug ("profile.vala:70: %s", _tmp3_);
		_g_free0 (_tmp3_);
		g_dbus_connection_unexport_menu_model (connection, self->priv->menu_export_id);
		self->priv->menu_export_id = (guint) 0;
	}
}

void
profile_spawn_command_line_async (Profile* self,
                                  const gchar* command)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (command != NULL);
	{
		g_spawn_command_line_async (command, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = string_to_string (command);
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		_tmp3_ = string_to_string (_tmp2_);
		_tmp4_ = g_strconcat ("Unable to launch '", _tmp0_, "': ", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		g_warning ("profile.vala:81: %s", _tmp5_);
		_g_free0 (_tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

GMenuItem*
profile_create_enabled_menuitem (Profile* self)
{
	GMenuItem* item = NULL;
	GMenuItem* _tmp0_;
	GMenuItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_menu_item_new (_ ("Bluetooth"), "indicator.bluetooth-enabled(true)");
	item = _tmp0_;
	g_menu_item_set_attribute (item, "x-ayatana-type", "s", "org.ayatana.indicator.switch", NULL);
	result = item;
	return result;
}

static GMenuItem*
profile_create_root_menuitem (Profile* self)
{
	GMenuItem* item = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GMenuItem* _tmp4_;
	GMenuItem* _tmp5_;
	GMenuItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->profile_name;
	_tmp1_ = string_to_string (_tmp0_);
	_tmp2_ = g_strconcat ("indicator.root-", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_menu_item_new (NULL, _tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	item = _tmp5_;
	g_menu_item_set_attribute (item, "x-ayatana-type", "s", "org.ayatana.indicator.root", NULL);
	result = item;
	return result;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Profile* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->action);
		_g_object_unref0 (_data1_->bluetooth);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda7_ (Block1Data* _data1_)
{
	Profile* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	self = _data1_->self;
	_tmp0_ = bluetooth_get_supported (_data1_->bluetooth);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_new_boolean (_tmp1_);
	g_variant_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	g_simple_action_set_state (_data1_->action, _tmp3_);
	_g_variant_unref0 (_tmp3_);
}

static void
___lambda7__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda7_ (self);
}

GAction*
profile_create_supported_action (Profile* self,
                                 Bluetooth* bluetooth)
{
	Block1Data* _data1_;
	Bluetooth* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GAction* _tmp7_;
	GAction* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (bluetooth != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (bluetooth);
	_g_object_unref0 (_data1_->bluetooth);
	_data1_->bluetooth = _tmp0_;
	_tmp1_ = bluetooth_get_supported (_data1_->bluetooth);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_new_boolean (_tmp2_);
	g_variant_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_simple_action_new_stateful ("bluetooth-supported", NULL, _tmp4_);
	_tmp6_ = _tmp5_;
	_g_variant_unref0 (_tmp4_);
	_data1_->action = _tmp6_;
	g_signal_connect_data ((GObject*) _data1_->bluetooth, "notify::supported", (GCallback) ___lambda7__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp7_ = _g_object_ref0 ((GAction*) _data1_->action);
	result = _tmp7_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		Profile* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->action);
		_g_object_unref0 (_data2_->bluetooth);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda8_ (Profile* self,
            GSimpleAction* action,
            GVariant* param)
{
	g_return_if_fail (action != NULL);
	g_signal_emit_by_name (action, "change-state", param);
}

static void
___lambda8__g_simple_action_activate (GSimpleAction* _sender,
                                      GVariant* parameter,
                                      gpointer self)
{
	__lambda8_ ((Profile*) self, _sender, parameter);
}

static void
__lambda9_ (Block2Data* _data2_,
            GSimpleAction* action,
            GVariant* requestedValue)
{
	Profile* self;
	self = _data2_->self;
	g_return_if_fail (action != NULL);
	bluetooth_try_set_enabled (_data2_->bluetooth, g_variant_get_boolean (requestedValue));
}

static void
___lambda9__g_simple_action_change_state (GSimpleAction* _sender,
                                          GVariant* value,
                                          gpointer self)
{
	__lambda9_ (self, _sender, value);
}

static void
__lambda10_ (Block2Data* _data2_)
{
	Profile* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	self = _data2_->self;
	_tmp0_ = bluetooth_get_enabled (_data2_->bluetooth);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_new_boolean (_tmp1_);
	g_variant_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	g_simple_action_set_state (_data2_->action, _tmp3_);
	_g_variant_unref0 (_tmp3_);
}

static void
___lambda10__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda10_ (self);
}

GAction*
profile_create_enabled_action (Profile* self,
                               Bluetooth* bluetooth)
{
	Block2Data* _data2_;
	Bluetooth* _tmp0_;
	const GVariantType* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GAction* _tmp8_;
	GAction* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (bluetooth != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (bluetooth);
	_g_object_unref0 (_data2_->bluetooth);
	_data2_->bluetooth = _tmp0_;
	_tmp1_ = G_VARIANT_TYPE_BOOLEAN;
	_tmp2_ = bluetooth_get_enabled (_data2_->bluetooth);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_variant_new_boolean (_tmp3_);
	g_variant_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_simple_action_new_stateful ("bluetooth-enabled", _tmp1_, _tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	_data2_->action = _tmp7_;
	g_signal_connect_object (_data2_->action, "activate", (GCallback) ___lambda8__g_simple_action_activate, self, 0);
	g_signal_connect_data (_data2_->action, "change-state", (GCallback) ___lambda9__g_simple_action_change_state, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	g_signal_connect_data ((GObject*) _data2_->bluetooth, "notify::enabled", (GCallback) ___lambda10__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp8_ = _g_object_ref0 ((GAction*) _data2_->action);
	result = _tmp8_;
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}

void
profile_update_root_action_state (Profile* self)
{
	GSimpleAction* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->root_action;
	_tmp1_ = profile_action_state_for_root (self);
	_tmp2_ = _tmp1_;
	g_simple_action_set_state (_tmp0_, _tmp2_);
	_g_variant_unref0 (_tmp2_);
}

GVariant*
profile_action_state_for_root (Profile* self)
{
	gchar* a11y = NULL;
	gchar* icon_name = NULL;
	Bluetooth* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GThemedIcon* icon = NULL;
	const gchar* _tmp12_;
	GThemedIcon* _tmp13_;
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp14_;
	GVariantType* _tmp15_;
	GVariantBuilder* _tmp16_;
	GVariantBuilder* _tmp17_;
	GVariantBuilder* _tmp18_;
	gboolean _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	gboolean _tmp22_ = FALSE;
	Bluetooth* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	GVariantBuilder* _tmp35_;
	GVariant* _tmp36_;
	GVariant* _tmp37_;
	GVariantBuilder* _tmp38_;
	GVariant* _tmp39_;
	GVariant* _tmp40_;
	GVariantBuilder* _tmp41_;
	GVariant* _tmp42_;
	GVariant* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->bluetooth;
	_tmp1_ = bluetooth_get_connected (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = g_strdup ("Bluetooth (connections)");
		_g_free0 (a11y);
		a11y = _tmp3_;
		_tmp4_ = g_strdup ("bluetooth-paired");
		_g_free0 (icon_name);
		icon_name = _tmp4_;
	} else {
		Bluetooth* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->bluetooth;
		_tmp6_ = bluetooth_get_enabled (_tmp5_);
		_tmp7_ = _tmp6_;
		if (_tmp7_) {
			gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp8_ = g_strdup ("Bluetooth (on)");
			_g_free0 (a11y);
			a11y = _tmp8_;
			_tmp9_ = g_strdup ("bluetooth-active");
			_g_free0 (icon_name);
			icon_name = _tmp9_;
		} else {
			gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp10_ = g_strdup ("Bluetooth (off)");
			_g_free0 (a11y);
			a11y = _tmp10_;
			_tmp11_ = g_strdup ("bluetooth-disabled");
			_g_free0 (icon_name);
			icon_name = _tmp11_;
		}
	}
	_tmp12_ = icon_name;
	_tmp13_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks (_tmp12_);
	icon = _tmp13_;
	_tmp14_ = g_variant_type_new ("a{sv}");
	_tmp15_ = _tmp14_;
	_tmp16_ = g_variant_builder_new (_tmp15_);
	_tmp17_ = _tmp16_;
	_g_variant_type_free0 (_tmp15_);
	builder = _tmp17_;
	_tmp18_ = builder;
	_tmp19_ = self->priv->_visible;
	_tmp20_ = g_variant_new_boolean (_tmp19_);
	g_variant_ref_sink (_tmp20_);
	_tmp21_ = _tmp20_;
	g_variant_builder_add (_tmp18_, "{sv}", "visible", _tmp21_, NULL);
	_g_variant_unref0 (_tmp21_);
	_tmp23_ = self->bluetooth;
	_tmp24_ = bluetooth_get_supported (_tmp23_);
	_tmp25_ = _tmp24_;
	if (_tmp25_) {
		gboolean _tmp26_;
		_tmp26_ = self->priv->_visible;
		_tmp22_ = _tmp26_;
	} else {
		_tmp22_ = FALSE;
	}
	if (_tmp22_) {
		GVariantBuilder* _tmp27_;
		const gchar* _tmp28_;
		GVariant* _tmp29_;
		GVariant* _tmp30_;
		GVariantBuilder* _tmp31_;
		GThemedIcon* _tmp32_;
		GVariant* _tmp33_;
		GVariant* _tmp34_;
		_tmp27_ = builder;
		_tmp28_ = a11y;
		_tmp29_ = g_variant_new_string (_tmp28_);
		g_variant_ref_sink (_tmp29_);
		_tmp30_ = _tmp29_;
		g_variant_builder_add (_tmp27_, "{sv}", "accessible-desc", _tmp30_, NULL);
		_g_variant_unref0 (_tmp30_);
		_tmp31_ = builder;
		_tmp32_ = icon;
		_tmp33_ = g_icon_serialize ((GIcon*) _tmp32_);
		_tmp34_ = _tmp33_;
		g_variant_builder_add (_tmp31_, "{sv}", "icon", _tmp34_, NULL);
		_g_variant_unref0 (_tmp34_);
	}
	_tmp35_ = builder;
	_tmp36_ = g_variant_new_string (_ ("Bluetooth"));
	g_variant_ref_sink (_tmp36_);
	_tmp37_ = _tmp36_;
	g_variant_builder_add (_tmp35_, "{sv}", "title", _tmp37_, NULL);
	_g_variant_unref0 (_tmp37_);
	_tmp38_ = builder;
	_tmp39_ = g_variant_new_string (_ ("Bluetooth status & device connections"));
	g_variant_ref_sink (_tmp39_);
	_tmp40_ = _tmp39_;
	g_variant_builder_add (_tmp38_, "{sv}", "tooltip", _tmp40_, NULL);
	_g_variant_unref0 (_tmp40_);
	_tmp41_ = builder;
	_tmp42_ = g_variant_builder_end (_tmp41_);
	g_variant_ref_sink (_tmp42_);
	result = _tmp42_;
	_g_variant_builder_unref0 (builder);
	_g_object_unref0 (icon);
	_g_free0 (icon_name);
	_g_free0 (a11y);
	return result;
}

gboolean
profile_get_visible (Profile* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_visible;
	return result;
}

void
profile_set_visible (Profile* self,
                     gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = profile_get_visible (self);
	if (old_value != value) {
		self->priv->_visible = value;
		g_object_notify_by_pspec ((GObject *) self, profile_properties[PROFILE_VISIBLE_PROPERTY]);
	}
}

static void
profile_class_init (ProfileClass * klass,
                    gpointer klass_data)
{
	profile_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Profile_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_profile_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_profile_set_property;
	G_OBJECT_CLASS (klass)->finalize = profile_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PROFILE_VISIBLE_PROPERTY, profile_properties[PROFILE_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
profile_instance_init (Profile * self,
                       gpointer klass)
{
	self->priv = profile_get_instance_private (self);
	self->priv->_visible = TRUE;
}

static void
profile_finalize (GObject * obj)
{
	Profile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PROFILE, Profile);
	_g_object_unref0 (self->bluetooth);
	_g_free0 (self->profile_name);
	_g_object_unref0 (self->root);
	_g_object_unref0 (self->menu);
	_g_object_unref0 (self->root_action);
	G_OBJECT_CLASS (profile_parent_class)->finalize (obj);
}

static GType
profile_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ProfileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) profile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Profile), 0, (GInstanceInitFunc) profile_instance_init, NULL };
	GType profile_type_id;
	profile_type_id = g_type_register_static (G_TYPE_OBJECT, "Profile", &g_define_type_info, 0);
	Profile_private_offset = g_type_add_instance_private (profile_type_id, sizeof (ProfilePrivate));
	return profile_type_id;
}

GType
profile_get_type (void)
{
	static volatile gsize profile_type_id__once = 0;
	if (g_once_init_enter (&profile_type_id__once)) {
		GType profile_type_id;
		profile_type_id = profile_get_type_once ();
		g_once_init_leave (&profile_type_id__once, profile_type_id);
	}
	return profile_type_id__once;
}

static void
_vala_profile_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	Profile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PROFILE, Profile);
	switch (property_id) {
		case PROFILE_VISIBLE_PROPERTY:
		g_value_set_boolean (value, profile_get_visible (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_profile_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	Profile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PROFILE, Profile);
	switch (property_id) {
		case PROFILE_VISIBLE_PROPERTY:
		profile_set_visible (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

